--***************************************************************
--
-- based on dural's mrGearbox2.lua
-- 
-- version 1.3 by mogli (biedens)
-- 2014/08/06
--
--***************************************************************

source(Utils.getFilename("mogliBase.lua", g_currentModDirectory))
mrGearboxMogli = mogliBase11.newSubclass()
mrGearboxMogli.huge = 1000000
mrGearboxMogli.factor30pi = 9.5492965855137201461330258023509
mrGearboxMogli.factorpi30 = 0.10471975511965977461542144610932
mrGearboxMogli.factor255  = 3.921568627450980392156862745098e-4
mrGearboxMogli.minTimeToShift = 100 
mrGearboxMogli.modifySound = true
mrGearboxMogli.rpmMinus = 100
mrGearboxMogli.rpmPlus = 200

function mrGearboxMogli.prerequisitesPresent(specializations) 
	return true
end 

function mrGearboxMogli:load(xmlFile) 
	local key = "vehicle.gearboxMogli"
	if hasXMLProperty(xmlFile, key) then
		mrGearboxMogli.initFromXml(self,xmlFile,key)
	end
end

function mrGearboxMogli.getNoNil2( v0, v1, v2, use2 )
	if v0 == nil then
		if v2 ~= nil and use2 then
			return v2
		end
		return v1
	end
	return v0
end

function mrGearboxMogli:initClient()		
	self.mrGbMSetGear           = mrGearboxMogli.mrGbMSetGear 
	self.mrGbMSetRange          = mrGearboxMogli.mrGbMSetRange 
	self.mrGbMSetRange2         = mrGearboxMogli.mrGbMSetRange2
	self.mrGbMSetAutomatic      = mrGearboxMogli.mrGbMSetAutomatic 
	self.mrGbMGetClutchPercent  = mrGearboxMogli.mrGbMGetClutchPercent 
	self.mrGbMDoGearShift       = mrGearboxMogli.mrGbMDoGearShift 

	mogliBase11.initStateHandling( self )
	mogliBase11.registerState( self, "mrGbMAutomatic",     false )
	mogliBase11.registerState( self, "mrGbMDrawText",      "off" )
	mogliBase11.registerState( self, "mrGbMIsOn",          false, mrGearboxMogli.mrGbMOnSetIsOn )
	mogliBase11.registerState( self, "mrGbMIsOnOff",       false )
	mogliBase11.registerState( self, "mrGbMReverseActive", false, mrGearboxMogli.mrGbMOnSetReverse )
	mogliBase11.registerState( self, "mrGbMNeutralActive", false, mrGearboxMogli.mrGbMOnSetNeutral ) 	
	mogliBase11.registerState( self, "mrGbMCurrentGear",   1,     mrGearboxMogli.mrGbMOnSetGear ) 
	mogliBase11.registerState( self, "mrGbMCurrentRange",  1,     mrGearboxMogli.mrGbMOnSetRange )
	mogliBase11.registerState( self, "mrGbMCurrentRange2", 1,     mrGearboxMogli.mrGbMOnSetRange2 )
	mogliBase11.registerState( self, "mrGbMWarningText",   "",    mrGearboxMogli.mrGbMOnSetWarningText )
	mogliBase11.registerState( self, "mrGbMAutoClutch",    true )
	mogliBase11.registerState( self, "mrGbMClutchTime",    0 )
	mogliBase11.registerState( self, "mrGbMManualClutch",  1,     mrGearboxMogli.mrGbMOnSetManualClutch, "float32" )
	mogliBase11.registerState( self, "mrGbMWantedMinRpmRatio", 0, nil, "float32" )
	
	self.mrGbMLastSumDt          = 0 
	self.mrGbMDrawRpm            = 0 
	self.mrGbMLastDrawRpm        = 0 
	self.mrGbMDrawClutch         = 0 
	self.mrGbMLastDrawClutch     = 0 
	self.mrGbMDrawLoad           = 0   
	self.mrGbMLastDrawLoad       = 0   
	self.mrGbMDrawSpeed          = 0 
	self.mrGbMLastDrawSpeed      = 0 
	self.mrGbMDrawFuel           = 0 
	self.mrGbMLastAxisForward    = 0
	self.mrGbMAutoShiftUpTimer   = 0
	self.mrGbMAutoShiftDownTimer = 0
	self.mrGbMCurrentGearSpeed   = 0	
	self.mrGbMWarningTimer       = 0	
	self.mrGbMGearShiftingNeeded = 0 
	self.mrGbMGearShiftingTime   = 0 
	self.mrGbMClutchShiftingTime = 0 
	self.mrGbMDoubleClutch       = false
	self.mrGbMDirtyFlag          = self:getNextDirtyFlag() 
	self.mrGbMWantedMinRpmRatio  = 0
	self.mrGbMWantedAcceleration = 0
	self.mrGbMLastMotorTorque    = 0
	self.mrGbMLastTransTorque    = 0
	self.realClutchPercent       = 0
	self.mrGbMClutchPercent      = 0	
end 

function mrGearboxMogli:initFromXml(xmlFile,xmlString) 

	mrGearboxMogli.initClient( self )		
	
	local excludeList = {}
	
	for n,_ in pairs(self) do
		if type(n) == "string" and string.sub(n,1,5) == "mrGbM" then
			excludeList[n] = true
		end
	end	
	
	self.mrGbMConfigVersion           = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. "#version" ),1.3)
	self.mrGbMDefaultOn               = Utils.getNoNil(getXMLBool( xmlFile, xmlString .. "#defaultOn" ),true)
	self.mrGbMSwapGearRangeKeys       = Utils.getNoNil(getXMLBool( xmlFile, xmlString .. "#swapGearRangeKeys" ),false)
	
	--self.mrGbMRatedRpm                = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. "#ratedRpm"), self.motor.maxRpm  )  --0.86* self.motor.minRpm) / self.mrGbMRatedRpm  
	self.mrGbMIdleRpm	                = self.motor.minRpm
	self.mrGbMRatedRpm                = self.motor.maxRpm

	self.mrGbMOpenRpm                 = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. "#clutchOpenRpm"), self.mrGbMIdleRpm-50) -- no automatic opening of clutch by default!!!
	self.mrGbMCloseRpm                = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. "#clutchCloseRpm"), self.mrGbMIdleRpm+100 )
	self.mrGbMAutoStartStop           = Utils.getNoNil(getXMLBool( xmlFile, xmlString .. "#autoStartStop"), true)
	self.mrGbMSpeedLimiter            = Utils.getNoNil(getXMLBool( xmlFile, xmlString .. "#speedLimiter"), self.mrGbMAutoStartStop)
	
	local clutchEngagingTimeMs = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. "#clutchEngagingTimeMs"), 500 )  -- 1000 = 1s
	self.mrGbMClutchTimeInc           = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. "#clutchTimeIncreaseMs"), 2 * clutchEngagingTimeMs )
	self.mrGbMClutchTimeDec           = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. "#clutchTimeDecreaseMs"), clutchEngagingTimeMs ) 		
	self.mrGbMClutchShiftTime         = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. "#clutchShiftingTimeMs"), 0.5 * self.mrGbMClutchTimeDec) 
	
	self.mrGbMTransmissionEfficiency  = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. "#transmissionEfficiency"), 0.93) / 0.88
	self.mrGbMTransmissionEfficiencyDec=Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. "#transmissionEfficiencyDec"), 0.07) / 0.88
		
	local alwaysDoubleClutch          = Utils.getNoNil(getXMLBool(xmlFile, xmlString .. "#doubleClutch"), false) 
	self.mrGbMGearsDoubleClutch       = Utils.getNoNil(getXMLBool(xmlFile, xmlString .. ".gears#doubleClutch"), alwaysDoubleClutch) 
	self.mrGbMRange1DoubleClutch      = Utils.getNoNil(getXMLBool(xmlFile, xmlString .. ".ranges(0)#doubleClutch"), alwaysDoubleClutch) 
	self.mrGbMRange2DoubleClutch      = Utils.getNoNil(getXMLBool(xmlFile, xmlString .. ".ranges(1)#doubleClutch"), alwaysDoubleClutch) 
	self.mrGbMReverseDoubleClutch     = Utils.getNoNil(getXMLBool(xmlFile, xmlString .. ".reverse#doubleClutch"), alwaysDoubleClutch) 
	
	self.mrGbMGearTimeToShiftGear     = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. ".gears#shiftTimeMs"),      800 )
	self.mrGbMGearTimeToShiftHl       = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. ".ranges(0)#shiftTimeMs"), 1000 ) 
	self.mrGbMGearTimeToShiftRanges2  = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. ".ranges(1)#shiftTimeMs"), 1200 ) 
	self.mrGbMGearTimeToShiftReverse  = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. ".reverse#shiftTimeMs"),   1000 ) 

	self.mrGbMClutchAfterShiftGear    = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. ".gears#clutchRatio"), 1) 
	self.mrGbMClutchAfterShiftHl      = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. ".ranges(0)#clutchRatio"), 0.7) 
	self.mrGbMClutchAfterShiftRanges2 = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. ".ranges(1)#clutchRatio"), 0.7) 
	self.mrGbMClutchAfterShiftReverse = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. ".reverse#clutchRatio"), 0 ) 
	self.mrGbMMinClutchPercent        = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. "#minClutchRatio"), 0.2 )
	self.mrGbMMaxClutchPercent        = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. "#maxClutchRatio"), 1 )
	self.mrGbMClutchTorqueClosed      = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. "#clutchTorqueClosed"), self.motor.maxClutchTorque )
	self.mrGbMClutchTorqueConst       = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. "#clutchTorqueConst"), self.motor.maxMotorTorque )
	self.mrGbMClutchTorqueDiff        = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. "#clutchTorqueDiff"), self.motor.maxClutchTorque - self.motor.maxMotorTorque )
	self.mrGbMClutchExponent          = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. "#clutchExponent"), 0.7 )
	self.mrGbMMaxClutchPercentInv     = 1 / self.mrGbMMaxClutchPercent

	self.mrGbMRealMotorBrakeFx        = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. "#motorBrakeFx"), 0.1 )
	self.mrGbMGlobalRatioFactor       = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. "#globalRatioFactor"), 1.025 )

	-- change of RPMs at 50 km/h
	self.mrGbMRpmIncFactor            = ( self.mrGbMRatedRpm - self.mrGbMIdleRpm ) / ( Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. "#revUpDownMs"), 2000 ) * 4.1 )
	self.mrGbMAutoShiftTimeout        = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. ".gears#autoShiftTimeout"), 4000 ) 
	self.mrGbMAutoShiftTimeout2       = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. ".gears#autoShiftTimeout2"),1000 ) 
	
	self.mrGbMIdlePitchFactor         = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. "#idlePitchFactor"), 1 ) * ( 1 + mrGearboxMogli.rpmPlus / self.mrGbMRatedRpm )
	self.mrGbMIdlePitchMax            = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. "#idlePitchMax"), -1 )
	self.mrGbMIdleVolumeFactor        = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. "#idleVolumeFactor"), 1 )
	self.mrGbMRunPitchFactor          = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. "#runPitchFactor"), 1 ) * ( 1 + mrGearboxMogli.rpmPlus / self.mrGbMRatedRpm )
	self.mrGbMRunPitchMax             = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. "#runPitchMax"), -1 )
	self.mrGbMRunVolumeFactor         = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. "#runVolumeFactor"), 1.4 )
		
	local reverseMinGear  = getXMLInt(xmlFile, xmlString .. ".reverse#minGear")
	local reverseMaxGear  = getXMLInt(xmlFile, xmlString .. ".reverse#maxGear")
	local reverseMinRange = getXMLInt(xmlFile, xmlString .. ".reverse#minRange")
	local reverseMaxRange = getXMLInt(xmlFile, xmlString .. ".reverse#maxRange")
	local rangeGearOffset = Utils.getNoNil(getXMLInt(xmlFile, xmlString .. ".ranges#gearOffset"), 0) 
	local gearRangeOffset = Utils.getNoNil(getXMLInt(xmlFile, xmlString .. ".gears#rangeOffset"), 0) 
		
	self.mrGbMGears = {} 
	local i = 0 
	while true do
		local baseName = xmlString .. string.format(".gears.gear(%d)", i) 		
		local speed    = getXMLFloat(xmlFile, baseName .. "#speed") 
		if speed==nil then
			break 
		end 
		i = i + 1 
		local name  = Utils.getNoNil(getXMLString(xmlFile, baseName .. "#name"), tostring(i)) 

		local fwdOnly = getXMLBool(xmlFile, baseName .. "#forwardOnly" )
		if fwdOnly == nil then
			fwdOnly = not ( ( reverseMinGear == nil or i >= reverseMinGear )
									and ( reverseMaxGear == nil or i <= reverseMaxGear ) )
		end		
		local revOnly = Utils.getNoNil( getXMLBool( xmlFile, baseName .. "#reverseOnly" ), false )
		
		local upRangeOffset   = Utils.getNoNil( getXMLInt( xmlFile, baseName .. "#upRangeOffset" ),  -gearRangeOffset ) 
		local downRangeOffset = Utils.getNoNil( getXMLInt( xmlFile, baseName .. "#downRangeOffset" ), gearRangeOffset ) 
		
		local newGear = {speed=speed/3.6,name=name,forwardOnly=fwdOnly,reverseOnly=revOnly,upRangeOffset=upRangeOffset,downRangeOffset=downRangeOffset} 
		
	--print(tostring(newGear.speed).." "..tostring(newGear.name).." "..tostring(newGear.forwardOnly).." "..tostring(newGear.reverseOnly).." "..tostring(newGear.upRangeOffset).." "..tostring(newGear.downRangeOffset))
					
		table.insert(self.mrGbMGears, newGear)  -- m/s
	end 	
	
	if i==0 then
		local newGear = {speed=self.motor.maxForwardSpeed/self.mrGbMGlobalRatioFactor,name="1",forwardOnly=false,reverseOnly=false,upRangeOffset=0,downRangeOffset=0} 
		table.insert(self.mrGbMGears, newGear)  -- m/s
	end 	
			
	self.mrGbMRanges = {} 
	i = 0 
	local generateNames = true 
	while true do
		local baseName = xmlString .. string.format(".ranges(0).range(%d)", i) 		
		local ratio = getXMLFloat(xmlFile, baseName .. "#ratio") 
		if ratio==nil then
			break 
		end 
		i = i + 1 
		
		local name = getXMLString(xmlFile, baseName .. "#name") 
		if name == nil then
			name = tostring(i) 
		else
			generateNames = false 
		end
		
		local fwdOnly = getXMLBool(xmlFile, baseName .. "#forwardOnly" )
		if fwdOnly == nil then
			fwdOnly = not ( ( reverseMinRange == nil or i >= reverseMinRange )
									and ( reverseMaxRange == nil or i <= reverseMaxRange ) )
		end		
		local revOnly = Utils.getNoNil( getXMLBool(xmlFile, baseName .. "#reverseOnly" ), false )
		
		local upGearOffset   = Utils.getNoNil( getXMLInt( xmlFile, baseName .. "#upGearOffset" ),  -rangeGearOffset ) 
		local downGearOffset = Utils.getNoNil( getXMLInt( xmlFile, baseName .. "#downGearOffset" ), rangeGearOffset ) 
		
		local newRange = {ratio=ratio,name=name,forwardOnly=fwdOnly,reverseOnly=revOnly,upGearOffset=upGearOffset,downGearOffset=downGearOffset} 
		
	--print(tostring(newRange.ratio).." "..tostring(newRange.name).." "..tostring(newRange.forwardOnly).." "..tostring(newRange.reverseOnly).." "..tostring(newRange.upGearOffset).." "..tostring(newRange.downGearOffset))
		
		table.insert(self.mrGbMRanges, newRange)  -- m/s
	end 
	
	if i==0 then
		local newRange = {ratio=1,name="",forwardOnly=false,reverseOnly=false,upGearOffset=0,downGearOffset=0} 
		table.insert(self.mrGbMRanges, newRange)  -- m/s
		generateNames = false
	end
	
	if generateNames then
		local fwd,rev=0,0
		for _,newRange in pairs( self.mrGbMRanges ) do
			if     newRange.forwardOnly then
				fwd = fwd + 1
			elseif newRange.reverseOnly then
				rev = rev + 1
			else
				fwd = fwd + 1
				rev = rev + 1
			end
		end
		
		local fwd2,rev2=0,0

		for _,newRange in pairs( self.mrGbMRanges ) do
			local isFwd,isRev=true,true
			if     newRange.forwardOnly then
				fwd2 = fwd2 + 1
				isRev = false
			elseif newRange.reverseOnly then
				rev2 = rev2 + 1
				isFwd = false
			else
				fwd2 = fwd2 + 1
				rev2 = rev2 + 1
			end
			if     isFwd then
				if     fwd == 1 then
					newRange.name = ""
				elseif fwd == 2 then
					if fwd2 == 1 then
						newRange.name = "L"
					else
						newRange.name = "H"
					end
				elseif fwd == 3 then
					if     fwd2 == 1 then
						newRange.name = "L"
					elseif fwd2 == 2 then
						newRange.name = "M"
					else
						newRange.name = "H"
					end
				elseif fwd == 4 then
					if     fwd2 == 1 then
						newRange.name = "S"
					elseif fwd2 == 2 then
						newRange.name = "L"
					elseif fwd2 == 3 then
						newRange.name = "M"
					else
						newRange.name = "H"
					end
				else
					newRange.name = "G"..tostring(fwd2)
				end
			elseif isRev then
				if rev==1 then
					newRange.name = "R"
				else
					newRange.name = "R"..tostring(rev2)
				end			
			end
		end		
	end
	
	self.mrGbMRanges2 = {} 
	i = 0 
	while true do
		local baseName = xmlString .. string.format(".ranges(1).range(%d)", i) 		
		local ratio = getXMLFloat(xmlFile, baseName .. "#ratio") 
		if ratio==nil then
			break 
		end 
		i = i + 1 
		
		local name = getXMLString(xmlFile, baseName .. "#name") 
		if name == nil then
			name = "G"..tostring(i) 
		end
		
		local fwdOnly = Utils.getNoNil( getXMLBool(xmlFile, baseName .. "#forwardOnly" ), false )
		local revOnly = Utils.getNoNil( getXMLBool(xmlFile, baseName .. "#reverseOnly" ), false )
		
		local newRange = {ratio=ratio,name=name,forwardOnly=fwdOnly,reverseOnly=revOnly} 
		table.insert(self.mrGbMRanges2, newRange)  -- m/s
	end 
	
	if i==0 then
		local newRange = {ratio=1,name="",forwardOnly=false,reverseOnly=false} 
		table.insert(self.mrGbMRanges2, newRange)  -- m/s
	end
		
	self.mrGbMReverseRatio            = Utils.getNoNil(getXMLFloat(xmlFile, xmlString .. ".reverse#ratio"), 1) 
	
	
	
	self.mrGbMReverseResetGear        = false 
	if getXMLBool(xmlFile, xmlString .. ".reverse#resetGear") or getXMLBool(xmlFile, xmlString .. ".gears#reverseReset") then
		self.mrGbMReverseResetGear      = true 
	end
	self.mrGbMReverseResetRange       = false 
	if getXMLBool(xmlFile, xmlString .. ".reverse#resetRange") or getXMLBool(xmlFile, xmlString .. ".ranges(0)#reverseReset") then
		self.mrGbMReverseResetRange     = true
	end
	self.mrGbMReverseResetRange2      = false
	if getXMLBool(xmlFile, xmlString .. ".ranges(1)#reverseReset") then
		self.mrGbMReverseResetRange2    = true
	end
	
	--RealisticUtils.testClass("mrGearboxMogli - mrGbMGears", self.mrGbMGears) 
	
	self.mrGbMDefaultGear     = Utils.getNoNil(getXMLInt(xmlFile, xmlString .. ".gears#defaultGear"), 1) 
	self.mrGbMDefaultRange    = Utils.getNoNil(getXMLInt(xmlFile, xmlString .. ".ranges(0)#defaultRange"), table.getn(self.mrGbMRanges)) 
	self.mrGbMDefaultRange2   = Utils.getNoNil(getXMLInt(xmlFile, xmlString .. ".ranges(1)#defaultRange"), table.getn(self.mrGbMRanges2)) 

	self.mrGbMAutoShiftUpRpm     = getXMLFloat(xmlFile, xmlString .. ".gears#autoUpRpm") 
	self.mrGbMAutoShiftDownRpm   = getXMLFloat(xmlFile, xmlString .. ".gears#autoDownRpm") 
	
	self.mrGbMAutoShiftMinMaxFactor = 1
	if self.mrGbMAutoShiftUpRpm  ~= nil and self.mrGbMAutoShiftDownRpm ~= nil then
		self.mrGbMAutoShiftMinMaxFactor = self.mrGbMAutoShiftUpRpm / self.mrGbMAutoShiftDownRpm
	end
	
	for n,_ in pairs(self) do
		if type(n) == "string" and string.sub(n,1,5) == "mrGbM" then
			if not ( excludeList[n] ) then
				mogliBase11.registerServerField( self, n )
			end
		end
	end	
			
-- set the default values for SERVER		
	self.mrGbMAutomatic     = self.mrGbMAutoShiftUpRpm ~= nil or self.mrGbMAutoShiftDownRpm ~= nil
	self.mrGbMIsOnOff       = self.mrGbMDefaultOn
	self.mrGbMNeutralActive = self.mrGbMAutoStartStop	
	self.mrGbMCurrentGear   = self.mrGbMDefaultGear
	self.mrGbMCurrentRange  = self.mrGbMDefaultRange
	self.mrGbMCurrentRange2 = self.mrGbMDefaultRange2
	self.mrGbMManualClutch  = self.mrGbMMaxClutchPercent
-- set the default values for SERVER		

	--if self.isClient then
	---- test
	--	print("======================================================")
	--
	--	local str = mogliBase11.toJson( self )
	--	print(str)
	--	
	--	self.mrGbMGears = nil
	--	
	--	mogliBase11.fromJson( self, str )
	--	
	--	print("======================================================")
	--end
	
	self.mrGbMRunHere = true
end
		
function mrGearboxMogli:update(dt)

	if mrGearboxMogli.modifySound and self:getIsActiveForSound() and self.mrGbMSoundPitchScale == nil and self.mrGbMSoundRunPitchScale == nil then
		self.mrGbMSoundPitchScale     = self.motorSoundPitchScale
		self.mrGbMSoundPitchMax       = self.motorSoundPitchMax
		self.mrGbMSoundRunPitchScale  = self.motorSoundRunPitchScale	
		self.mrGbMSoundRunPitchMax    = self.motorSoundRunPitchMax
		self.mrGbMSoundVolume         = self.sampleMotor.volume   
		self.mrGbMSoundRunVolume      = self.sampleMotorRun.volume
		self.mrGbMSoundVolume         = self.sampleMotor.volume        
		self.mrGbMSoundPitchOffset    = self.sampleMotor.pitchOffset   
		self.mrGbMSoundVolume         = self.sampleMotor.volume        
		self.mrGbMSoundRunPitchOffset = self.sampleMotorRun.pitchOffset
	end

	if self:getIsActiveForInput(false) and InputBinding.hasEvent(InputBinding.mrGearboxMogliON_OFF) then
		self:mbSetState11( "mrGbMIsOnOff", not self.mrGbMIsOnOff ) 
	end

	if      self.isMotorStarted 
			and self.mrGbMIsOnOff 
			and self.mrGbMMotor == nil then 
-- initialize as late as possible 			
		if not ( self.mbClientInitDone11 ) then return end
		if self.motor == nil then return end
	
		if self.mrGbMRunHere then
			self:mbSetState11( "mrGbMCurrentGear",   mrGearboxMogli.mrGbMGetNewEntry( self, self.mrGbMGears,   self.mrGbMDefaultGear,   "gear" ) )
			self:mbSetState11( "mrGbMCurrentRange",  mrGearboxMogli.mrGbMGetNewEntry( self, self.mrGbMRanges,  self.mrGbMDefaultRange,  "range" ) )
			self:mbSetState11( "mrGbMCurrentRange2", mrGearboxMogli.mrGbMGetNewEntry( self, self.mrGbMRanges2, self.mrGbMDefaultRange2, "range2" ) )
		end
		
		if self.mrGbMMotor == nil then
			self.mrGbMMotor       = mrGearboxMogliMotor:new( self, self.motor )			
			self.mrGbMBackupMotor = self.motor	
		end
	elseif self.mrGbMMotor == nil then 
-- not initialized => exit	
		return
	end
	
	if self.mrGbMBackupMotor == nil then 
-- no backup of original motor => error in mrGearboxMogliMotor:new
		self.mrGbMMotor = nil
		self:mbSetState11( "mrGbMIsOn", false ) 	
		return 
	end
	
	if not self.mrGbMIsOn then
		return 
	end 
	
-- switch the motor 
	self.motor = self.mrGbMMotor

-- text	
	if self.mrGbMRunHere then
		local text = ""
		if self.isAITractorActivated or self.isAIThreshing then
			text = "AI"
		elseif not ( self.isMotorStarted ) then
			text = "off"
		elseif self.mrGbMNeutralActive then
			if self.mrGbMReverseActive then
				text = "neutral (R)" 	
			else
				text = "neutral" 	
			end
		elseif self.mrGbMAutomatic then
			if self.mrGbMReverseActive then
				text = "auto (R)" 	
			else
				text = "auto"
			end
		else
			if self.mrGbMReverseActive then
				text = "reverse" 	
			else
				text = "manual" 	
			end
		end
		
		self:mbSetState11( "mrGbMDrawText", text )
	end
	
-- inputs	
	if self:getIsActiveForInput(false) then
		local driveControlShuttle = false
		if      g_currentMission.driveControl ~= nil 
				and g_currentMission.driveControl.useModules ~= nil
				and g_currentMission.driveControl.useModules.shuttle
				and self.driveControl ~= nil
				and self.driveControl.shuttle ~= nil 
				and self.driveControl.shuttle.isActive then
			--driveControlShuttle = true
			--if     self.driveControl.shuttle.direction > 0 then
			--	self:mbSetState11( "mrGbMReverseActive", false ) 
			--elseif self.driveControl.shuttle.direction < 0 then
			--	self:mbSetState11( "mrGbMReverseActive", true ) 
			--else
			--	self:mbSetState11( "mrGbMNeutralActive", true) 
			--end
			self.mrGbMEnableDCShuttle = true
			self.driveControl.shuttle.isActive = false
		end
		
		if      self.mrGbMWarningText ~= nil
				and self.mrGbMWarningText ~= "" then
			if g_currentMission.time < self.mrGbMWarningTimer then
				g_currentMission:addWarning(self.mrGbMWarningText, 0.018, 0.033)
			else
				self.mrGbMWarningText = ""
			end
		end
		-- auto start/stop
		if      self.mrGbMAutoStartStop
				and self.mrGbMNeutralActive 			
				and ( self.mrGbMLastAxisForward < -0.1 or self.cruiseControl.state ~= 0 ) then
			self:mbSetState11( "mrGbMNeutralActive", false) 
		end

		if InputBinding.hasEvent(InputBinding.mrGearboxMogliAUTOCLUTCH) then
			self:mbSetState11( "mrGbMAutoClutch", not self.mrGbMAutoClutch ) 
		end

		local targetClutchPercent = InputBinding.getDigitalInputAxis(InputBinding.mrGearboxMogliCLUTCH)
		if InputBinding.isAxisZero(targetClutchPercent) then
			targetClutchPercent = InputBinding.getAnalogInputAxis(InputBinding.mrGearboxMogliCLUTCH)
			if not InputBinding.isAxisZero(targetClutchPercent) then
				targetClutchPercent = Utils.clamp( 0.55 * ( targetClutchPercent + 1 ), 0, 1 ) * self.mrGbMMaxClutchPercent
				if math.abs( targetClutchPercent - self.mrGbMManualClutch ) > 0.01 then
					self:mbSetState11( "mrGbMClutchTime", g_currentMission.time )
				end
				self:mbSetState11( "mrGbMManualClutch", targetClutchPercent ) 
			end
		elseif targetClutchPercent < 0 then
			self:mbSetState11( "mrGbMClutchTime", g_currentMission.time )
			self:mbSetState11( "mrGbMManualClutch", math.max( 0, self.mrGbMManualClutch - dt/self.mrGbMClutchTimeDec ))
		elseif targetClutchPercent > 0 then
			self:mbSetState11( "mrGbMClutchTime", g_currentMission.time )
			self:mbSetState11( "mrGbMManualClutch", math.min( self.mrGbMMaxClutchPercent, self.mrGbMManualClutch + dt/self.mrGbMClutchTimeInc ))
		end
		
		local handThrottle = InputBinding.getDigitalInputAxis(InputBinding.mrGearboxMogliMINRPM)
		if InputBinding.isAxisZero(handThrottle) then
			handThrottle = InputBinding.getAnalogInputAxis(InputBinding.mrGearboxMogliMINRPM)
			if not InputBinding.isAxisZero(handThrottle) then
				self:mbSetState11( "mrGbMWantedMinRpmRatio", Utils.clamp( handThrottle, 0, 1 ))
			end
		elseif handThrottle < 0 then
			self:mbSetState11( "mrGbMWantedMinRpmRatio", math.max( 0, self.mrGbMWantedMinRpmRatio - 0.001 * dt )) 
		elseif handThrottle > 0 then
			self:mbSetState11( "mrGbMWantedMinRpmRatio", math.min( 1, self.mrGbMWantedMinRpmRatio + 0.001 * dt )) 
		end
			
		if     InputBinding.hasEvent(InputBinding.mrGearboxMogliNEUTRAL) then
			if self.mrGbMAutoShiftUpRpm ~= nil or self.mrGbMAutoShiftDownRpm ~= nil then
				if self.mrGbMNeutralActive == self.mrGbMAutomatic then
					self:mbSetState11( "mrGbMNeutralActive", not self.mrGbMNeutralActive ) 
					self:mrGbMSetAutomatic( true ) 
				else
					self:mrGbMSetAutomatic( not self.mrGbMAutomatic ) 
				end					
			else	
				if not self.mrGbMNeutralActive then
					self:setCruiseControlState(0)
				end
				self:mbSetState11( "mrGbMNeutralActive", not self.mrGbMNeutralActive ) 
			end
		elseif not ( driveControlShuttle ) and InputBinding.hasEvent(InputBinding.mrGearboxMogliREVERSE) then			
			self:setCruiseControlState(0)
			self:mbSetState11( "mrGbMReverseActive", not self.mrGbMReverseActive ) 
		elseif InputBinding.hasEvent(InputBinding.mrGearboxMogliSHIFTRANGE2UP) then -- high/low range shift
			self:mrGbMSetRange2(self.mrGbMCurrentRange2+1)                                        
		elseif InputBinding.hasEvent(InputBinding.mrGearboxMogliSHIFTRANGE2DOWN) then -- high/low range shift
			self:mrGbMSetRange2(self.mrGbMCurrentRange2-1) 
		elseif InputBinding.hasEvent(InputBinding.mrGearboxMogliSHIFTRANGEUP) then -- high/low range shift
			if self.mrGbMSwapGearRangeKeys then
				self:mrGbMSetGear(self.mrGbMCurrentGear+1) 
			else
				self:mrGbMSetRange(self.mrGbMCurrentRange+1)                                        
			end 
		elseif InputBinding.hasEvent(InputBinding.mrGearboxMogliSHIFTRANGEDOWN) then -- high/low range shift
			if self.mrGbMSwapGearRangeKeys then
				self:mrGbMSetGear(self.mrGbMCurrentGear-1) 	
			else
				self:mrGbMSetRange(self.mrGbMCurrentRange-1) 
			end 
		elseif InputBinding.hasEvent(InputBinding.mrGearboxMogliSHIFTGEARUP) then
			if self.mrGbMSwapGearRangeKeys then
				self:mrGbMSetRange(self.mrGbMCurrentRange+1)                                        
			else
				self:mrGbMSetGear(self.mrGbMCurrentGear+1) 
			end 
		elseif InputBinding.hasEvent(InputBinding.mrGearboxMogliSHIFTGEARDOWN) then
			if self.mrGbMSwapGearRangeKeys then
				self:mrGbMSetRange(self.mrGbMCurrentRange-1) 
			else
				self:mrGbMSetGear(self.mrGbMCurrentGear-1) 	
			end 
		elseif InputBinding.hasEvent(InputBinding.mrGearboxMogliGEAR1) then if self.mrGbMSwapGearRangeKeys then self:mrGbMSetRange(1) else self:mrGbMSetGear(1) end 
		elseif InputBinding.hasEvent(InputBinding.mrGearboxMogliGEAR2) then if self.mrGbMSwapGearRangeKeys then self:mrGbMSetRange(2) else self:mrGbMSetGear(2) end 
		elseif InputBinding.hasEvent(InputBinding.mrGearboxMogliGEAR3) then if self.mrGbMSwapGearRangeKeys then self:mrGbMSetRange(3) else self:mrGbMSetGear(3) end 
		elseif InputBinding.hasEvent(InputBinding.mrGearboxMogliGEAR4) then if self.mrGbMSwapGearRangeKeys then self:mrGbMSetRange(4) else self:mrGbMSetGear(4) end 
		elseif InputBinding.hasEvent(InputBinding.mrGearboxMogliGEAR5) then if self.mrGbMSwapGearRangeKeys then self:mrGbMSetRange(5) else self:mrGbMSetGear(5) end 
		elseif InputBinding.hasEvent(InputBinding.mrGearboxMogliGEAR6) then if self.mrGbMSwapGearRangeKeys then self:mrGbMSetRange(6) else self:mrGbMSetGear(6) end 
		elseif InputBinding.hasEvent(InputBinding.mrGearboxMogliGEARFWD)  then self:setCruiseControlState(0) self:mbSetState11( "mrGbMReverseActive", false ) 
		elseif InputBinding.hasEvent(InputBinding.mrGearboxMogliGEARBACK) then self:setCruiseControlState(0) self:mbSetState11( "mrGbMReverseActive", true ) 
		end 
	end 

	if mrGearboxMogli.modifySound and self:getIsActiveForSound() and ( self.mrGbMSoundPitchScale ~= nil or self.mrGbMSoundRunPitchScale ~= nil ) then			
		self.motorSoundPitchScale    = self.mrGbMSoundPitchScale    * self.mrGbMIdlePitchFactor		
		self.motorSoundRunPitchScale = self.mrGbMSoundRunPitchScale * self.mrGbMRunPitchFactor
		
		local old
		old = self.sampleMotor.volume
		self.sampleMotor.volume      = self.mrGbMSoundVolume        * self.mrGbMIdleVolumeFactor
		if old ~= self.sampleMotor.volume and self.sampleMotor.sample ~= nil then
			setSampleVolume( self.sampleMotor.sample, self.sampleMotor.volume )
		end
		
		old = self.sampleMotorRun.volume
		self.sampleMotorRun.volume   = self.mrGbMSoundRunVolume     * self.mrGbMRunVolumeFactor
		if old ~= self.sampleMotorRun.volume and self.sampleMotorRun.sample ~= nil then
			setSampleVolume( self.sampleMotorRun.sample, self.sampleMotorRun.volume )
		end
		
		if     self.mrGbMIdlePitchMax < 0 then 
			self.motorSoundPitchMax    = self.sampleMotor.pitchOffset + self.motorSoundPitchScale * self.motor.maxRpm / 60
		elseif self.mrGbMIdlePitchMax > 0 then 
			self.motorSoundPitchMax    = self.mrGbMIdlePitchMax
		else
			self.motorSoundPitchMax    = self.mrGbMSoundPitchMax
		end 
				
		if     self.mrGbMRunPitchMax < 0 then 
			self.motorSoundRunPitchMax = self.sampleMotorRun.pitchOffset + self.motorSoundRunPitchScale * self.motor.maxRpm / 60
		elseif self.mrGbMRunPitchMax > 0 then 
			self.motorSoundRunPitchMax = self.mrGbMRunPitchMax
		else
			self.motorSoundRunPitchMax = self.mrGbMSoundRunPitchMax
		end 
	end
--**********************************************************************************************************		
	
end 

function mrGearboxMogli:updateTick(dt)

	if self.mrGbMMotor == nil then return end

	if self.isActive then
		if self.mrGbMRunHere then
			if self.isAITractorActivated or self.isAIThreshing then
				if self.mrGbMIsOn then
					self:mbSetState11( "mrGbMNeutralActive", true )
				end
				self:mbSetState11( "mrGbMIsOn", false ) 				
			elseif  self.isMotorStarted 
					and self.mrGbMIsOnOff then
				self:mbSetState11( "mrGbMIsOn", true ) 
			else		
				self:mbSetState11( "mrGbMIsOn", false ) 
			end 	
		
			if self.mrGbMIsOn then	
					self.mrGbMLastSumDt = self.mrGbMLastSumDt + dt
				
				if self.mrGbMLastSumDt > 200 then
					self.mrGbMDrawRpm    = tonumber( Utils.clamp( math.floor(self.mrGbMMotor.lastMotorRpm*255/self.motor.maxRpm+0.5), 0, 255 ))	 				
					self.mrGbMDrawClutch = tonumber( Utils.clamp( math.floor(math.min( self.realClutchPercent, self.mrGbMManualClutch ) * self.mrGbMMaxClutchPercentInv*200+0.5), 0, 255 ))	
					self.mrGbMDrawLoad   = tonumber( Utils.clamp( math.floor(Utils.getNoNil(self.mrGbMMotor.motorLoadS,0)*20+0.5)*5, 0, 255 ))	
					self.mrGbMDrawSpeed  = tonumber( Utils.clamp( math.floor(self.mrGbMCurrentGearSpeed / self.mrGbMGlobalRatioFactor * 3.6 + 0.5 ), 0, 255 ))	

					if self.mrGbMLastFuelFillLevel == nil then
						self.mrGbMLastFuelFillLevel = self.fuelFillLevel
						self.mrGbMDrawFuel          = 0
					else
						local fuelUsed = self.mrGbMLastFuelFillLevel - self.fuelFillLevel
						self.mrGbMLastFuelFillLevel = self.fuelFillLevel
						self.mrGbMDrawFuel          = fuelUsed * (1000 * 3600) / self.mrGbMLastSumDt
					end
					
					if     self.mrGbMLastDrawRpm    ~= self.mrGbMDrawRpm
							or self.mrGbMLastDrawClutch ~= self.mrGbMDrawClutch
							or self.mrGbMLastDrawLoad   ~= self.mrGbMDrawLoad   
							or self.mrGbMLastDrawSpeed  ~= self.mrGbMDrawSpeed 
							then
						self:raiseDirtyFlags(self.mrGbMDirtyFlag) 
					
						self.mrGbMLastDrawRpm    = self.mrGbMDrawRpm
						self.mrGbMLastDrawClutch = self.mrGbMDrawClutch
						self.mrGbMLastDrawLoad   = self.mrGbMDrawLoad   
						self.mrGbMLastDrawSpeed  = self.mrGbMDrawSpeed 
					end 
					
					self.mrGbMLastSumDt = 0
				end 
			else
				self.mrGbMLastSumDt         = 0
				self.mrGbMLastFuelFillLevel = self.fuelFillLevel
			end
		end
	end
end 

function mrGearboxMogli:readUpdateStream(streamId, timestamp, connection)
  if connection:getIsServer() then
		if streamReadBool( streamId ) then
			self.mrGbMDrawRpm    = streamReadUInt8( streamId ) 
			self.mrGbMDrawClutch = streamReadUInt8( streamId ) 
			self.mrGbMDrawLoad   = streamReadUInt8( streamId )  
			self.mrGbMDrawSpeed  = streamReadUInt8( streamId ) 
		end 
  end 
end 

function mrGearboxMogli:writeUpdateStream(streamId, connection, dirtyMask)
  if not connection:getIsServer() then
		if streamWriteBool(streamId, bitAND(dirtyMask, self.mrGbMDirtyFlag) ~= 0) then	
			streamWriteUInt8(streamId, self.mrGbMDrawRpm    ) 
			streamWriteUInt8(streamId, self.mrGbMDrawClutch ) 
			streamWriteUInt8(streamId, self.mrGbMDrawLoad   ) 
			streamWriteUInt8(streamId, self.mrGbMDrawSpeed  ) 
		end 
	end 
end 

function mrGearboxMogli:deleteMap()
	if mrGearboxMogli.backgroundOverlayId ~= nil then
		pcall( delete, mrGearboxMogli.backgroundOverlayId )
		mrGearboxMogli.backgroundOverlayId = nil
	end
end

function mrGearboxMogli:draw() 	
	
	if self.mrGbMMotor == nil then return end
	
	if self.mrGbMIsOn then
		if mrGearboxMogli.backgroundOverlayId == nil then
			mrGearboxMogli.backgroundOverlayId = createImageOverlay( "dataS2/menu/blank.png" )
			setOverlayColor( mrGearboxMogli.backgroundOverlayId, 0,0,0, 0.4 )
		end	
		
		local drawY0   = 0.706
		local deltaY   = 0.02

		local ovTop    = drawY0 + 0.06  -- title plus 0.03 plus character size of title (0.03)
		local ovRows   = 6
		if self.mrGbMDrawSpeed > 0 then
			ovRows = ovRows + 1
		end
		local ovH      = 0.03 + 0.02 + ovRows * deltaY -- title is 0.03 points above drawY0; add border of 0.01 x 2
		local ovY      = ovTop - ovH
		
		renderOverlay( mrGearboxMogli.backgroundOverlayId, 0.84, ovY, 0.16, ovH )
	
		setTextAlignment(RenderText.ALIGN_LEFT) 
		setTextColor(1, 1, 1, 1) 

		setTextBold(true) 
		renderText(0.85, drawY0 + 0.03, 0.03, self.mrGbMDrawText) 			     	
		setTextBold(false) 
		
		local gearText = self.mrGbMGears[self.mrGbMCurrentGear].name
		if self.mrGbMRanges[self.mrGbMCurrentRange].name ~= nil and self.mrGbMRanges[self.mrGbMCurrentRange].name ~= "" then
			if self.mrGbMSwapGearRangeKeys then
				gearText = gearText .." ".. self.mrGbMRanges[self.mrGbMCurrentRange].name
			else
				gearText = self.mrGbMRanges[self.mrGbMCurrentRange].name .." ".. gearText
			end
		end
		if self.mrGbMRanges2[self.mrGbMCurrentRange2].name ~= nil and self.mrGbMRanges2[self.mrGbMCurrentRange2].name ~= "" then
			gearText = self.mrGbMRanges2[self.mrGbMCurrentRange2].name .." ".. gearText
		end
		
		local drawY    = drawY0 
		
		renderText(0.85, drawY, deltaY, gearText) 			     
		if self.mrGbMDrawSpeed > 0 then
			drawY = drawY - deltaY renderText(0.85, drawY, deltaY, "Speed.................")
		end
		drawY = drawY - deltaY renderText(0.85, drawY, deltaY, "Rpm...................")
		drawY = drawY - deltaY renderText(0.85, drawY, deltaY, "Load..................")
		drawY = drawY - deltaY renderText(0.85, drawY, deltaY, "Fuel used.............")
		if self.mrGbMAutoClutch then 
			drawY = drawY - deltaY renderText(0.85, drawY, deltaY, "Auto clutch...........")
		else
			drawY = drawY - deltaY renderText(0.85, drawY, deltaY, "Clutch................")
		end
		drawY = drawY - deltaY renderText(0.85, drawY, deltaY, "Hand throttle.........")	

		--if self.mrGbMRunHere then
		--	drawY = drawY - deltaY renderText(0.85, drawY, deltaY, "Max poss. Rpm.........")
		--end 
		
		setTextAlignment(RenderText.ALIGN_RIGHT) 
		drawY    = drawY0 
		
		if self.mrGbMDrawSpeed > 0 then
			drawY = drawY - deltaY renderText(0.99,drawY,deltaY, string.format("%3.1f km/h", self.mrGbMDrawSpeed ))
		end
		drawY = drawY - deltaY renderText(0.99, drawY, deltaY, string.format("%4.0f", math.floor(self.mrGbMDrawRpm * self.motor.maxRpm * mrGearboxMogli.factor255 +0.5)*10)) 		
		drawY = drawY - deltaY renderText(0.99, drawY, deltaY, string.format("%3d %%", self.mrGbMDrawLoad )) 	
		drawY = drawY - deltaY renderText(0.99, drawY, deltaY, string.format("%3d l/h", self.mrGbMDrawFuel ))  		          
		if self.mrGbMAutoClutch then 
			drawY = drawY - deltaY renderText(0.99, drawY, deltaY, string.format("%3.0f %%", self.mrGbMDrawClutch*0.5 )) 
		else
			drawY = drawY - deltaY renderText(0.99, drawY, deltaY, string.format("%3.0f %%", math.floor( self.mrGbMManualClutch * self.mrGbMMaxClutchPercentInv * 100 + 0.5 ) ))
		end
		drawY = drawY - deltaY renderText(0.99, drawY, deltaY, string.format("%3d %%", math.floor( self.mrGbMWantedMinRpmRatio * 100 + 0.5 ) ))  		          

		--if self.mrGbMRunHere then
		--	drawY = drawY - deltaY renderText(0.99, drawY, deltaY, string.format("%3.0f", math.floor( self.mrGbMMotor.maxPossibleRpm*0.1+0.5)*10)) 		
		--end
		
		setTextAlignment(RenderText.ALIGN_LEFT) 
		setTextBold(false)
		
		g_currentMission:addHelpButtonText(mogliBase11.getText("mrGearboxMogliON"),  InputBinding.mrGearboxMogliON_OFF);		
	else
		g_currentMission:addHelpButtonText(mogliBase11.getText("mrGearboxMogliOFF"), InputBinding.mrGearboxMogliON_OFF);		
	end
	
end 

function mrGearboxMogli:getSaveAttributesAndNodes(nodeIdent)

	local attributes = ""

	attributes = attributes.." mrGbMCurrentGear=\""  .. tostring(self.mrGbMCurrentGear  ) .. "\""
	attributes = attributes.." mrGbMCurrentRange=\"" .. tostring(self.mrGbMCurrentRange ) .. "\""
	attributes = attributes.." mrGbMCurrentRange2=\"" ..tostring(self.mrGbMCurrentRange2 ) .. "\""
	attributes = attributes.." mrGbMAutoClutch=\"" ..   tostring(self.mrGbMAutoClutch ) .. "\""

	return attributes
end 

function mrGearboxMogli:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
	local i, b
	
	i = getXMLInt(xmlFile, key .. "#mrGbMCurrentGear" )
	if i ~= nil then
		self.mrGbMDefaultGear = i
	end

	i = getXMLInt(xmlFile, key .. "#mrGbMCurrentRange" )
	if i ~= nil then
		self.mrGbMDefaultRange = i
	end
	
	i = getXMLInt(xmlFile, key .. "#mrGbMCurrentRange2" )
	if i ~= nil then
		self.mrGbMDefaultRange2 = i
	end

	b = getXMLBool(xmlFile, key .. "#mrGbMAutoClutch" )
	if b ~= nil then
		self.mrGbMAutoClutch = b
	end

	--self:mbSetState11( "mrGbMFirstTimeRun", false )
	
	return BaseMission.VEHICLE_LOAD_OK
end 

function mrGearboxMogli:mrGbMGetNewEntry( entries, index, name )

	local new = Utils.clamp( index, 1, table.getn( entries ) )

	if self.mrGbMReverseActive then
		if new > self.mrGbMCurrentGear then
			while entries[new].forwardOnly and new < table.getn( entries ) do
				new = new + 1
			end
		end
		while entries[new].forwardOnly and new > 1 do
			new = new -1
		end
		if entries[new].forwardOnly then
			while entries[new].forwardOnly and new < table.getn( entries ) do
				new = new + 1
			end
		end
		if entries[new].forwardOnly then
			print(string.format("no reverse %s found: %d", index, name))
		end
	else
		if new > self.mrGbMCurrentGear then
			while entries[new].reverseOnly and new < table.getn( entries ) do
				new = new + 1
			end
		end
		while entries[new].reverseOnly and new > 1 do
			new = new -1
		end
		if entries[new].reverseOnly then
			while entries[new].reverseOnly and new < table.getn( entries ) do
				new = new + 1
			end
		end
		if entries[new].reverseOnly then
			print(string.format("no forward %s found: %d", index, name))
		end
	end
	
	return new
end

function mrGearboxMogli:mrGbMSpeedLevelCheck( newGear, newRange, newRange2 )
	--if self.cruiseControl.state ~= 0 then
	--	local maxGearSpeed = 0
	--	if self.mrGbMAutomatic then
	--		if newRange == self.mrGbMCurrentRange and newRange2 == self.mrGbMCurrentRange2 then
	--			return true
	--		end
	--		for i,g in pairs( self.mrGbMGears ) do
	--			if      maxGearSpeed < g.speed
	--					and ( not ( g.forwardOnly ) or ( g.forwardOnly and not ( self.mrGbMReverseActive ) ) 
	--				     or not ( g.reverseOnly ) or ( g.reverseOnly and self.mrGbMReverseActive ) ) then
	--				maxGearSpeed = g.speed
	--			end
	--		end
	--		maxGearSpeed = maxGearSpeed * 3.6
	--	else
	--		maxGearSpeed = 3.6 * self.mrGbMGears[newGear].speed 
	--	end
	--	maxGearSpeed = maxGearSpeed * self.mrGbMRanges[newRange].ratio 
	--														  * self.mrGbMRanges2[newRange2].ratio
	--														  * self.mrGbMGlobalRatioFactor  
	--	if self.mrGbMReverseActive then	
	--		maxGearSpeed = maxGearSpeed * self.mrGbMReverseRatio 
	--	end
	--	if maxGearSpeed < self.mrGbMMotor.speedLimit then
	--		local gearText = self.mrGbMGears[newGear].name
	--		if self.mrGbMRanges[newRange].name ~= nil and self.mrGbMRanges[newRange].name ~= "" then
	--			gearText = self.mrGbMRanges[newRange].name .." ".. gearText
	--		end           
	--		if self.mrGbMRanges2[newRange2].name ~= nil and self.mrGbMRanges2[newRange2].name ~= "" then
	--			gearText = self.mrGbMRanges2[newRange2].name .." ".. gearText
	--		end
	--	
	--		self:mbSetState11( "mrGbMWarningText", string.format( "Gear %s is too low for speed level %d", gearText, self.mrGbMMotor.speedLevel ))
  --
	--		return false
	--	end
	--end
	
	return true
end

function mrGearboxMogli:mrGbMSetGear( new, noEventSend)
	if      not ( self.mrGbMAutoClutch )
			and self.mrGbMManualClutch > self.mrGbMClutchAfterShiftGear + 0.1 
			and self.mrGbMManualClutch > self.mrGbMClutchPercent then
		return
	end		

	local newGear  = mrGearboxMogli.mrGbMGetNewEntry( self, self.mrGbMGears, new, "gear" )
	local newRange = self.mrGbMCurrentRange
	if not self.mrGbMAutomatic then
		if     newGear > self.mrGbMCurrentGear then 
			newRange = self.mrGbMCurrentRange + self.mrGbMGears[self.mrGbMCurrentGear].upRangeOffset
		elseif newGear < self.mrGbMCurrentGear then 
			newRange = self.mrGbMCurrentRange + self.mrGbMGears[self.mrGbMCurrentGear].downRangeOffset
		end
		newRange = mrGearboxMogli.mrGbMGetNewEntry( self, self.mrGbMRanges, newRange, "range" )
	end
	
	if      newGear ~= self.mrGbMCurrentGear 
			and mrGearboxMogli.mrGbMSpeedLevelCheck( self, newGear, newRange, self.mrGbMCurrentRange2 ) then
		self:mbSetState11( "mrGbMCurrentGear",  newGear,  noEventSend ) 		
		self:mbSetState11( "mrGbMCurrentRange", newRange, noEventSend ) 
	end
end 

function mrGearboxMogli:mrGbMSetRange(new, noEventSend)
	if      not ( self.mrGbMAutoClutch )
			and self.mrGbMManualClutch > self.mrGbMClutchAfterShiftHl + 0.1 
			and self.mrGbMManualClutch > self.mrGbMClutchPercent then
		return
	end		

	local newRange = mrGearboxMogli.mrGbMGetNewEntry( self, self.mrGbMRanges, new, "range" )
	local newGear  = self.mrGbMCurrentGear
	if     newRange > self.mrGbMCurrentRange then 
		newGear = self.mrGbMCurrentGear + self.mrGbMRanges[self.mrGbMCurrentRange].upGearOffset
	elseif newRange < self.mrGbMCurrentRange then  
		newGear = self.mrGbMCurrentGear + self.mrGbMRanges[self.mrGbMCurrentRange].downGearOffset
	end
	newGear = mrGearboxMogli.mrGbMGetNewEntry( self, self.mrGbMGears, newGear, "gear" )
	
	if      newRange ~= self.mrGbMCurrentRange
			and mrGearboxMogli.mrGbMSpeedLevelCheck( self, newGear, newRange, self.mrGbMCurrentRange2 ) then
		self:mbSetState11( "mrGbMCurrentRange", newRange, noEventSend ) 
		self:mbSetState11( "mrGbMCurrentGear",  newGear,  noEventSend ) 		
	end
end

function mrGearboxMogli:mrGbMSetRange2(new, noEventSend)
	if      not ( self.mrGbMAutoClutch )
			and self.mrGbMManualClutch > self.mrGbMClutchAfterShiftRanges2 + 0.1 
			and self.mrGbMManualClutch > self.mrGbMClutchPercent then
		return
	end		

	local newRange2 = mrGearboxMogli.mrGbMGetNewEntry( self, self.mrGbMRanges2, new, "range2" )
	
	if      newRange2 ~= self.mrGbMCurrentRange2
			and mrGearboxMogli.mrGbMSpeedLevelCheck( self, self.mrGbMCurrentGear, self.mrGbMCurrentRange, newRange2 ) then
		self:mbSetState11( "mrGbMCurrentRange2", newRange2, noEventSend ) 
	end
end

function mrGearboxMogli:mrGbMSetAutomatic( value, noEventSend )
	local new = false 
	if value and ( self.mrGbMAutoShiftUpRpm ~= nil or self.mrGbMAutoShiftDownRpm ~= nil ) then
		new = true 
	end 
	self:mbSetState11( "mrGbMAutomatic", new, noEventSend ) 		
end 

function mrGearboxMogli:mrGbMPrepareGearShift( timeToShift, clutchPercent, doubleClutch )
	if self.mrGbMRunHere then
		self.mrGbMGearShiftingNeeded  = 1 
		self.mrGbMGearShiftingTime    = math.max( self.mrGbMGearShiftingTime, g_currentMission.time + math.max( timeToShift, mrGearboxMogli.minTimeToShift ) ) 
		self.mrGbMClutchPercent       = math.min( self.realClutchPercent, clutchPercent ) 
		
		if self.mrGbMMotor ~= nil then
			self.mrGbMWheelRpmBeforeShift = self.mrGbMMotor.wheelRpmS
			self.mrGbMMotor.rpmIncFactor  = self.mrGbMRpmIncFactor * 8.2
		else
			self.mrGbMWheelRpmBeforeShift = nil
    end 
		
		self.mrGbMAfterShiftRpm       = self.motor.maxRpm
		if not ( self.mrGbMAutoClutch ) then
			self.mrGbMDoubleClutch       = false
		elseif doubleClutch then
			self.mrGbMDoubleClutch       = true
			self.mrGbMClutchShiftingTime = math.max( self.mrGbMClutchShiftingTime, g_currentMission.time + 0.4 * timeToShift ) 
		else
			self.mrGbMDoubleClutch       = false
			self.mrGbMClutchShiftingTime = math.max( self.mrGbMClutchShiftingTime, g_currentMission.time + self.mrGbMClutchShiftTime ) 
		end
	else
		print("ERROR: mrGearboxMogli:mrGbMPrepareGearShift called at client")
	end 
end

function mrGearboxMogli:mrGbMDoGearShift(increaseOnly)
	if self.mrGbMRunHere then
		if self.mrGbMDoubleClutch then
			self.mrGbMGearShiftingNeeded = 2
		else
			self.mrGbMGearShiftingNeeded = 3
		end
		local gearMaxSpeed = self.mrGbMGears[self.mrGbMCurrentGear].speed 
		                   * self.mrGbMRanges[self.mrGbMCurrentRange].ratio 
											 * self.mrGbMRanges2[self.mrGbMCurrentRange2].ratio
											 * self.mrGbMGlobalRatioFactor
		if self.mrGbMReverseActive then	
			gearMaxSpeed = gearMaxSpeed * self.mrGbMReverseRatio 
		end
		
		--mogliBase11.debugEvent( self, gearMaxSpeed, self.mrGbMCurrentGearSpeed, increaseOnly )
		
		local lastGearSpeed = Utils.getNoNil( self.mrGbMCurrentGearSpeed, 0 )
		
		if increaseOnly then
			self.mrGbMCurrentGearSpeed = math.max( gearMaxSpeed, self.mrGbMCurrentGearSpeed )
		else
			self.mrGbMCurrentGearSpeed = gearMaxSpeed 
		end
		
		if self.mrGbMMotor ~= nil then			
			self.mrGbMMotor.rpmIncFactor= self.mrGbMRpmIncFactor * math.sqrt( math.abs( mrGearboxMogli.gearSpeedToRatio( self, self.mrGbMCurrentGearSpeed ) ) )
		end
		
		if self.mrGbMWheelRpmBeforeShift ~= nil then
			local last = self.mrGbMMotor.wheelRpmS
			self.mrGbMMotor.wheelRpmS = self.mrGbMWheelRpmBeforeShift * lastGearSpeed / self.mrGbMCurrentGearSpeed
			self.mrGbMAfterShiftRpm   = (1-self.mrGbMClutchPercent) * self.mrGbMRatedRpm + self.mrGbMClutchPercent * self.mrGbMMotor.wheelRpmS		
		elseif self.mrGbMMotor ~= nil then
			self.mrGbMMotor.wheelRpmS = self.mrGbMMotor.maxRpm
			self.mrGbMAfterShiftRpm   = self.mrGbMMotor.maxRpm
		end
		
		self.mrGbMDebugTime       = nil
		--print("mrGbM gear shift done: "..tostring(math.floor(g_currentMission.time*0.001))
		--													.." "..tostring(self.mrGbMCurrentGear)
		--													.." "..tostring(self.mrGbMCurrentRange)
		--													.." "..tostring(self.mrGbMCurrentRange2)
		--													.." "..tostring(self.mrGbMReverseActive)
		--													.." "..tostring(math.floor(gearMaxSpeed*3.6+0.5))
		--													.." "..tostring(self.isServer)
		--													.." "..tostring(self.isClient))
	end 
end 

function mrGearboxMogli:mrGbMOnSetReverse( old, new, noEventSend )

	self.mrGbMReverseActive = new 
	--timer to shift the "reverse/forward"
	if self.mrGbMRunHere then
		mrGearboxMogli.mrGbMPrepareGearShift( self, self.mrGbMGearTimeToShiftReverse, self.mrGbMClutchAfterShiftReverse, self.mrGbMReverseDoubleClutch ) 
	end
	
	local default = self.mrGbMCurrentGear
	if self.mrGbMReverseResetGear then
		default = self.mrGbMDefaultGear
	end
	
	self:mbSetState11( "mrGbMDefaultGear", self.mrGbMCurrentGear, noEventSend ) 
	self:mbSetState11( "mrGbMCurrentGear", mrGearboxMogli.mrGbMGetNewEntry( self, self.mrGbMGears, default, "gear" ), noEventSend ) 
	
	local default = self.mrGbMCurrentRange
	if self.mrGbMReverseResetRange then
		default = self.mrGbMDefaultRange
	end

	self:mbSetState11( "mrGbMDefaultRange", self.mrGbMCurrentRange, noEventSend ) 
	self:mbSetState11( "mrGbMCurrentRange", mrGearboxMogli.mrGbMGetNewEntry( self, self.mrGbMRanges, default, "range" ), noEventSend ) 

	local default = self.mrGbMCurrentRange2
	if self.mrGbMReverseResetRange2 then
		default = self.mrGbMDefaultRange2
	end

	self:mbSetState11( "mrGbMDefaultRange2", self.mrGbMCurrentRange2, noEventSend ) 
	self:mbSetState11( "mrGbMCurrentRange2", mrGearboxMogli.mrGbMGetNewEntry( self, self.mrGbMRanges2, default, "range2" ), noEventSend ) 
	
	if self.mrGbMRunHere then
		self.mrGbMAutoShiftDownTimer = g_currentMission.time + self.mrGbMAutoShiftTimeout 
		self.mrGbMAutoShiftUpTimer   = g_currentMission.time + self.mrGbMAutoShiftTimeout 
	end 
end 
		
function mrGearboxMogli:mrGbMOnSetNeutral( old, new, noEventSend )		
	self.mrGbMNeutralActive = new 
	
	if self.mrGbMRunHere then
		mrGearboxMogli.mrGbMPrepareGearShift( self, 0, 1 ) 
		self.mrGbMAutoShiftDownTimer = 0
		self.mrGbMAutoShiftUpTimer   = 0
	end
end 

function mrGearboxMogli:mrGbMOnSetRange( old, new, noEventSend )
		
	self.mrGbMCurrentRange = new

	--timer to shift the "range"
	if self.mrGbMRunHere then
		mrGearboxMogli.mrGbMPrepareGearShift( self, self.mrGbMGearTimeToShiftHl, self.mrGbMClutchAfterShiftHl, self.mrGbMRange1DoubleClutch ) 
		self.mrGbMAutoShiftDownTimer = 0
		self.mrGbMAutoShiftUpTimer   = 0
	end 
end 

function mrGearboxMogli:mrGbMOnSetRange2( old, new, noEventSend )
		
	self.mrGbMCurrentRange2 = new

	--timer to shift the "range 2"
	if self.mrGbMRunHere then	
		mrGearboxMogli.mrGbMPrepareGearShift( self, self.mrGbMGearTimeToShiftRanges2, self.mrGbMClutchAfterShiftRanges2, self.mrGbMRange2DoubleClutch ) 
		self.mrGbMAutoShiftDownTimer = 0
		self.mrGbMAutoShiftUpTimer   = 0
	end 
end 

function mrGearboxMogli:mrGbMOnSetGear( old, new, noEventSend )

	if     new > self.mrGbMCurrentGear then
		if self.mrGbMRunHere then
			self.mrGbMAutoShiftDownTimer = g_currentMission.time + self.mrGbMAutoShiftTimeout 
			self.mrGbMAutoShiftUpTimer   = g_currentMission.time + self.mrGbMAutoShiftTimeout2
		end 
	elseif new < self.mrGbMCurrentGear then                                              
		if self.mrGbMRunHere then
			self.mrGbMAutoShiftDownTimer = g_currentMission.time + self.mrGbMAutoShiftTimeout2
			self.mrGbMAutoShiftUpTimer   = g_currentMission.time + self.mrGbMAutoShiftTimeout 
		end 
	end			
	
	self.mrGbMCurrentGear = new
	
	if self.mrGbMRunHere then	
	-- adjust clutch % to fit rpm after gear shift	
		local clutchPercent = self.mrGbMClutchAfterShiftGear
		if clutchPercent < 0 then
			local gearSpeed = self.mrGbMGears[new].speed * self.mrGbMRanges[self.mrGbMCurrentRange].ratio * self.mrGbMRanges2[self.mrGbMCurrentRange2].ratio * self.mrGbMGlobalRatioFactor
			if self.mrGbMReverseActive then	
				gearSpeed = gearSpeed * self.mrGbMReverseRatio 
			end
			clutchPercent = Utils.clamp( mrGearboxMogli.mrGbMGetClutchPercent( self, self.mrGbMRatedRpm, self.mrGbMMotor.currentRpmS, gearSpeed ), self.mrGbMMinClutchPercent, self.mrGbMMaxClutchPercent )
		end
	
		--timer to set the gear
		mrGearboxMogli.mrGbMPrepareGearShift( self, self.mrGbMGearTimeToShiftGear, clutchPercent, self.mrGbMGearsDoubleClutch ) 	 	
	end
end

function mrGearboxMogli:mrGbMOnSetIsOn( old, new, noEventSend )

	self.mrGbMIsOn = new 
		
	if self.mrGbMIsOn then				
		if      g_currentMission.driveControl ~= nil 
				and g_currentMission.driveControl.useModules ~= nil
				and g_currentMission.driveControl.useModules.shuttle
				and self.driveControl ~= nil
				and self.driveControl.shuttle ~= nil 
				and self.driveControl.shuttle.isActive then
			if self.driveControl.shuttle.direction < 0 then
				self:mbSetState11( "mrGbMReverseActive", true, noEventSend )  -- first gear, H range, reverse
			else
				self:mbSetState11( "mrGbMReverseActive", false, noEventSend )  -- first gear, H range, forward
			end
		end
		if self.mrGbMMotor ~= nil then
			mrGearboxMogliMotor.copyRuntimeValues( self.motor, self.mrGbMMotor )
			self.motor = self.mrGbMMotor
		end
		self:mrGbMDoGearShift() 
	elseif old and self.mrGbMMotor ~= nil then
		if self.mrGbMRunHere then
			self:mbSetState11( "mrGbMDefaultGear", self.mrGbMCurrentGear, noEventSend ) 
			self:mbSetState11( "mrGbMDefaultRange", self.mrGbMCurrentRange, noEventSend ) 
			self:mbSetState11( "mrGbMDefaultRange2", self.mrGbMCurrentRange2, noEventSend ) 
		end
		self.mrGbMGearShiftingNeeded = 0 	
		if self.mrGbMBackupMotor ~= nil then
			mrGearboxMogliMotor.copyRuntimeValues( self.motor, self.mrGbMBackupMotor )
			self.motor = self.mrGbMBackupMotor
		end
		if self.mrGbMEnableDCShuttle then
			self.mrGbMEnableDCShuttle = false
			self.driveControl.shuttle.isActive = true
			if self.mrGbMReverseActive then
				self.driveControl.shuttle.direction = -1
			else
				self.driveControl.shuttle.direction = 1
			end
		end
	end
	
	if self.mrGbMSoundPitchScale ~= nil or self.mrGbMSoundRunPitchScale ~= nil then
		self.motorSoundPitchScale       = self.mrGbMSoundPitchScale
		self.motorSoundPitchMax         = self.mrGbMSoundPitchMax
		self.motorSoundRunPitchScale    = self.mrGbMSoundRunPitchScale	
		self.motorSoundRunPitchMax      = self.mrGbMSoundRunPitchMax			
		self.sampleMotor.volume         = self.mrGbMSoundVolume
		self.sampleMotor.pitchOffset    = self.mrGbMSoundPitchOffset
		self.sampleMotor.volume         = self.mrGbMSoundVolume
		self.sampleMotorRun.pitchOffset = self.mrGbMSoundRunPitchOffset
	end 
end 

function mrGearboxMogli:mrGbMOnSetWarningText( old, new, noEventSend )
	self.mrGbMWarningText  = new
  self.mrGbMWarningTimer = g_currentMission.time + 2000
end


--**********************************************************************************************************	
-- mrGearboxMogli:newUpdateWheelsPhysics
--**********************************************************************************************************	
function mrGearboxMogli:newUpdateWheelsPhysics( superFunc, dt, currentSpeed, acceleration, doHandbrake, requiredDriveMode, ... )
	if not ( self.mrGbMIsOn ) or self.motor ~= self.mrGbMMotor then		
		return superFunc( self, dt, currentSpeed, acceleration, doHandbrake, requiredDriveMode, ... )
	end
	
-- driveControl and GPS
	if      g_currentMission.driveControl ~= nil 
			and g_currentMission.driveControl.useModules ~= nil
			and g_currentMission.driveControl.useModules.shuttle
			and self.driveControl ~= nil
			and self.driveControl.shuttle ~= nil 
			and self.driveControl.shuttle.isActive then
		-- in general driveControlShuttle should be switched off
		acceleration = self.driveControl.shuttle.direction * acceleration
	elseif self.mrGbMReverseActive then
		self.GPSmovingDirection    = -1
		self.GPSmovingDirectionCnt = 40
	else
		self.GPSmovingDirection    =  1
		self.GPSmovingDirectionCnt = 40
	end	
		
	self.mrGbMLastAxisForward = -acceleration
	local accelerationPedal   = 0
	local brakePedal          = 0
	local brakeLights         = false

	if     doHandbrake or self.mrGbMNeutralActive then
		-- hand brake
		if math.abs(self.rotatedTime) < 0.01 or self.articulatedAxis == nil then
			brakePedal = 1
		end
	elseif acceleration < -0.001 then
		-- braking 
		brakePedal  = -acceleration
		brakeLights = true		
	elseif acceleration < 0.001 then
		-- just rolling 
		if currentSpeed < self.mrGbMMotor.lowBrakeForceSpeedLimit then
			if math.abs(self.rotatedTime) < 0.01 or self.articulatedAxis == nil then
				brakePedal = 1
			end
		else
			brakePedal = self.mrGbMMotor.lowBrakeForceScale
		end
	elseif self.mrGbMReverseActive then
		-- reverse 
		accelerationPedal          = -acceleration
	else
		-- forward 
		accelerationPedal          =  acceleration
	end
	
	if      brakePedal <= 0 
			and ( ( self.movingDirection * currentSpeed >  0.0003 and self.mrGbMReverseActive )
			   or ( self.movingDirection * currentSpeed < -0.0003 and not ( self.mrGbMReverseActive ) ) ) then
		-- wrong direction 
		brakePedal  = 1
		brakeLights = true
	end

	self.setBrakeLightsVisibility(self, brakeLights)
	self.setReverseLightsVisibility(self, self.mrGbMReverseActive)
	self.mrGbMMotor:updateMotorRpm(dt)	
	self.mrGbMMotor:updateGear(acceleration, dt)	

	local absAccelerationPedal = math.abs(accelerationPedal)
	local wheelDriveTorque = 0
	
	if absAccelerationPedal < self.mrGbMMotor.minThrottle then
		absAccelerationPedal = self.mrGbMMotor.minThrottle
		if self.mrGbMReverseActive then
			accelerationPedal = -absAccelerationPedal
		else
			accelerationPedal =  absAccelerationPedal
		end		
	end		

	if next(self.differentials) ~= nil and self.motorizedNode ~= nil then
		local maxRotSpeed = self.mrGbMMotor:getCurMaxRpm() * mrGearboxMogli.factorpi30
		local torque      = self.mrGbMMotor:getTorque(accelerationPedal, false)
						
		local mct = 5 --self.mrGbMClutchTorqueClosed
		if self.mrGbMMotor.clutchPercent < 1E-3 then
			mct = 0
		elseif self.mrGbMMotor.nonClampedMotorRpm < self.mrGbMMotor.stallRpm then
			mct = 0
		else
			local c = self.mrGbMMotor.clutchPercent
			if self.mrGbMClutchExponent < 0.999 or self.mrGbMClutchExponent > 1.001 then	
				c = c ^ self.mrGbMClutchExponent
			end
			mct = c * ( self.mrGbMClutchTorqueConst + self.mrGbMClutchTorqueDiff * Utils.clamp( ( self.mrGbMMotor.nonClampedMotorRpm - self.mrGbMMotor.maxPossibleRpm ) / self.mrGbMRatedRpm, 0, 1 )^2 )
    
			local f1 = 0.9
			local f2 = 1 - f1
			if self.mrGbMMotor.clutchPercent > f1 then
				mct = math.max( self.mrGbMClutchTorqueClosed * ( self.mrGbMMotor.clutchPercent - f1 ) / f2, mct )
			end
		end
		
		local ratio = self.mrGbMMotor:getGearRatio()
		
		--print(string.format("aIn: %1.2f aP: %1.2f T: %3.1f maxRpm: %4.0f ratio: %4.0f mct: %1.1f", acceleration, accelerationPedal, torque, maxRotSpeed, ratio, mct))
		
		setVehicleProps(self.motorizedNode, torque, maxRotSpeed, ratio, mct)
	else
		local numTouching = 0
		local numNotTouching = 0
		local numHandbrake = 0
		local axleSpeedSum = 0

		for _, wheel in pairs(self.wheels) do
			if requiredDriveMode <= wheel.driveMode then
				if doHandbrake and wheel.hasHandbrake then
					numHandbrake = numHandbrake + 1
				elseif wheel.hasGroundContact then
					numTouching = numTouching + 1
				else
					numNotTouching = numNotTouching + 1
				end
			end
		end

		if 0 < numTouching and 0.01 < absAccelerationPedal then
			local axisTorque, brakePedalMotor = WheelsUtil.getWheelTorque(self, accelerationPedal)

			if axisTorque ~= 0 then
				wheelDriveTorque = axisTorque/(numTouching + numNotTouching)
			else
				brakePedal = brakePedalMotor
			end
		end
	end

	doBrake = 0 < brakePedal

	for _, implement in pairs(self.attachedImplements) do
		if implement.object ~= nil then
			if doBrake then
				implement.object:onBrake(brakePedal)
			else
				implement.object:onReleaseBrake()
			end
		end
	end

	for _, wheel in pairs(self.wheels) do
		WheelsUtil.updateWheelPhysics(self, wheel, doHandbrake, wheelDriveTorque, brakePedal, requiredDriveMode, dt)
	end

	return 
end

--**********************************************************************************************************	
-- mrGearboxMogli:gearSpeedToRatio
--**********************************************************************************************************	
function mrGearboxMogli:gearSpeedToRatio( gearSpeed )
	if gearSpeed > 1E-6 then 
		return math.min( self.mrGbMRatedRpm / ( gearSpeed * mrGearboxMogli.factor30pi ), mrGearboxMogli.huge )
	else
		return mrGearboxMogli.huge 
	end
end




--**********************************************************************************************************	
-- mrGearboxMogliMotor
--**********************************************************************************************************	

mrGearboxMogliMotor = {}
mrGearboxMogliMotor_mt = Class(mrGearboxMogliMotor)

setmetatable( mrGearboxMogliMotor, { __index = function (table, key) return VehicleMotor[key] end } )

--**********************************************************************************************************	
-- 
--**********************************************************************************************************	
function mrGearboxMogliMotor:new( vehicle, motor )
	local self = {}

	setmetatable(self, mrGearboxMogliMotor_mt)

	self.vehicle        = vehicle
	self.original       = motor 
	
	self.torqueCurve    = AnimCurve:new( motor.torqueCurve.interpolator, motor.torqueCurve.interpolatorDegree )
	local zeroTorqueRpm = 0.5*motor.minRpm
	local idleTorque    = motor.torqueCurve:get(motor.minRpm)
	self.torqueCurve:addKeyframe( {v=0.1*idleTorque, time=0} )
	self.torqueCurve:addKeyframe( {v=0.5*idleTorque, time=zeroTorqueRpm} )
	local vMax  = 0
	local tMax  = motor.maxRpm
	local tvMax = 0
	local vvMax = 0
	for _,k in pairs(motor.torqueCurve.keyframes) do
		if k.time > zeroTorqueRpm then 
			--k.time = zeroTorqueRpm + ( k.time - zeroTorqueRpm ) * mrGbMRatedRpm / motor.original.maxRpm
			if vvMax < k.v then
				vvMax = k.v
				tvMax = k.time
			end
			
			local kv = k.v
			local kt = k.time
			
			--if ( kv < vvMax or kt > motor.maxRpm - 200 ) then
			--	local ref = math.min( tvMax, motor.maxRpm - 200 )
			--	kt = ref + ( motor.maxRpm - 100 - ref ) * ( kt - ref ) / ( motor.maxRpm - ref )
			--	kv = kv * k.time / kt
			--end
			--print(tostring(k.time).." "..tostring(k.v).." "..tostring(k.time*k.v).." => "..tostring(kt).." "..tostring(kv).." "..tostring(kt*kv))
			
			vMax = kv
			tMax = kt
			self.torqueCurve:addKeyframe( {v=kv, time=kt} )
			
		end
	end		

	if vMax > 0 then
		self.torqueCurve:addKeyframe( {v=0.9*vMax, time=tMax + 25} )
		self.torqueCurve:addKeyframe( {v=0.5*vMax, time=tMax + 50} )
		self.torqueCurve:addKeyframe( {v=0.1*vMax, time=tMax + 75} )
		self.torqueCurve:addKeyframe( {v=0, time=tMax + 100} )
	end

	self.idleRpm                 = vehicle.mrGbMIdleRpm
	self.ratedRpm                = vehicle.mrGbMRatedRpm
	
	self.minRpm                  = math.max( self.idleRpm  - mrGearboxMogli.rpmMinus, 0 )
	self.maxRpm                  = self.ratedRpm + mrGearboxMogli.rpmPlus
	self.stallRpm                = motor.minRpm + 10
	
	mrGearboxMogliMotor.copyRuntimeValues( motor, self )
	
	self.prevNonClampedMotorRpm  = motor.nonClampedMotorRpm
	
	self.minRequiredRpm          = self.idleRpm
	self.maxForwardSpeed         = motor.maxForwardSpeed
	self.maxBackwardSpeed        = motor.maxBackwardSpeed
	self.maxClutchTorque         = motor.maxClutchTorque
	self.brakeForce              = motor.brakeForce
	self.gear                    = 0
	self.gearRatio               = 0
	self.forwardGearRatios       = motor.forwardGearRatio
	self.backwardGearRatios      = motor.backwardGearRatio
	self.minForwardGearRatio     = motor.minForwardGearRatio
	self.maxForwardGearRatio     = motor.maxForwardGearRatio
	self.minBackwardGearRatio    = motor.minBackwardGearRatio
	self.maxBackwardGearRatio    = motor.maxBackwardGearRatio
	self.rpmFadeOutRange         = motor.rpmFadeOutRange
	self.clutchRpm               = 0
	self.motorLoad               = 0
	self.requiredWheelTorque     = 0

	self.maxForwardSpeed         = motor.maxForwardSpeed
	self.maxBackwardSpeed        = motor.maxBackwardSpeed
	self.ptoMotorRpmRatio        = motor.ptoMotorRpmRatio

	self.maxMotorTorque          = self.torqueCurve:getMaximum()
	self.maxTorque               = motor.maxTorque
	self.lowBrakeForceScale      = vehicle.mrGbMRealMotorBrakeFx --motor.lowBrakeForceScale
	self.lowBrakeForceSpeedLimit = motor.lowBrakeForceSpeedLimit
		
	self.maxPossibleRpm          = motor.maxRpm
	self.wheelRpmS               = 0
	self.currentRpmS             = 0
	self.noTransmission          = true
	self.noTorque                = false
	self.motorLoadS              = 0
	self.clutchPercent           = 0
	self.slipFactor              = 1
	self.rpmIncFactor  	         = vehicle.mrGbMRpmIncFactor * math.sqrt( math.abs( mrGearboxMogli.gearSpeedToRatio( vehicle, vehicle.mrGbMCurrentGearSpeed ) ) )
	self.minThrottle             = 0.3
	self.minThrottleS            = 0.3
	self.prevNonClampedMotorRpm  = 0
	
	return self
end

function mrGearboxMogliMotor.copyRuntimeValues( motorFrom, motorTo )

	motorTo.nonClampedMotorRpm      = motorFrom.nonClampedMotorRpm 
	motorTo.clutchRpm               = motorFrom.clutchRpm          
	motorTo.motorLoad               = motorFrom.motorLoad          
	motorTo.requiredWheelTorque     = motorFrom.requiredWheelTorque
	motorTo.lastMotorRpm            = motorFrom.lastMotorRpm       
	motorTo.gear                    = motorFrom.gear               
	motorTo.gearRatio               = motorFrom.gearRatio          
	motorTo.rpmLimit                = motorFrom.rpmLimit 
	motorTo.speedLimit              = motorFrom.speedLimit

end

--**********************************************************************************************************	
-- mrGearboxMogliMotor:getCurMaxRpm
--**********************************************************************************************************	
function mrGearboxMogliMotor:getCurMaxRpm()

	local maxRpm    = math.max( self.maxPossibleRpm, self.minRequiredRpm )
	local gearRatio = mrGearboxMogli.gearSpeedToRatio( self.vehicle, self.vehicle.mrGbMCurrentGearSpeed )

	if gearRatio ~= 0 then
		local speedLimit = self.speedLimit*0.277778

		if self.vehicle.mrGbMSpeedLimiter then
			if self.vehicle.mrGbMReverseActive then
				speedLimit = math.min(speedLimit, self.maxBackwardSpeed)
			else
				speedLimit = math.min(speedLimit, self.maxForwardSpeed)
			end
		end

		maxRpm = math.min(maxRpm, speedLimit * mrGearboxMogli.factor30pi * math.abs(gearRatio))
	end
	
	maxRpm = math.min(maxRpm, self.rpmLimit)

	return maxRpm
end

--**********************************************************************************************************	
-- mrGearboxMogliMotor:getBestGear
--**********************************************************************************************************	
function mrGearboxMogliMotor:getBestGear( acceleration, wheelSpeedRpm, accSafeMotorRpm, requiredWheelTorque, requiredMotorRpm )

	local bestGearRatio = mrGearboxMogli.gearSpeedToRatio( self.vehicle, self.vehicle.mrGbMCurrentGearSpeed )

	local absWheelSpeedRpm = wheelSpeedRpm
	if self.vehicle.mrGbMReverseActive then
		absWheelSpeedRpm = -wheelSpeedRpm
	end
	absWheelSpeedRpm = math.max( absWheelSpeedRpm, 1E-6 )
	local maxGearRatio = self.original.maxForwardGearRatio
	if maxGearRatio < bestGearRatio + bestGearRatio then
		maxGearRatio = bestGearRatio + bestGearRatio
	end
	
	if     self.clutchPercent < 1E-3 then 
		bestGearRatio = maxGearRatio
	elseif self.clutchPercent < 1 then
	  
		local factor1 = self.maxRpm / math.max( absWheelSpeedRpm * bestGearRatio, 1E-6 )
		local factor2 = self.clutchPercent + ( 1 - self.clutchPercent ) * math.abs( acceleration ) * factor1
		bestGearRatio = math.min( bestGearRatio * math.max( factor2, 1 ), maxGearRatio )
		
		if bestGearRatio * absWheelSpeedRpm < self.idleRpm then
			bestGearRatio = math.min( self.idleRpm / absWheelSpeedRpm, maxGearRatio )
		end
		
		--local minGearRatio = bestGearRatio
		--local maxGearRatio = math.min( bestGearRatio / self.clutchPercent, 1000 )
		--
		--bestGearRatio  = self.getBestGearRatio(self, absWheelSpeedRpm, minGearRatio, maxGearRatio, accSafeMotorRpm, requiredWheelTorque/math.abs(acceleration), requiredMotorRpm)				
	end
	

	if self.vehicle.mrGbMReverseActive then
		return -1, -bestGearRatio
	else
		return 1, bestGearRatio
	end
end

--**********************************************************************************************************	
-- mrGearboxMogliMotor:getTorque
--**********************************************************************************************************	
function mrGearboxMogliMotor:getTorque( acceleration, limitRpm )

	if self.noTorque then
		return 0, 0
	end
	
	local torque     = self.torqueCurve:get( self.nonClampedMotorRpm )	
	local brakePedal = 0

	if limitRpm then
		local maxRpm = self.maxRpm
		local rpmFadeOutRange = self.rpmFadeOutRange*mrGearboxMogli.gearSpeedToRatio( self.vehicle, self.vehicle.mrGbMCurrentGearSpeed )
		local fadeStartRpm = maxRpm - rpmFadeOutRange

		if fadeStartRpm < self.nonClampedMotorRpm then
			if maxRpm < self.nonClampedMotorRpm then
				brakePedal = math.min((self.nonClampedMotorRpm - maxRpm)/rpmFadeOutRange, 1)
				torque = 0
			else
				torque = torque*math.max((fadeStartRpm - self.nonClampedMotorRpm)/rpmFadeOutRange, 0)
			end
		end
	end

	torque = torque*math.abs(acceleration)
	self.mrGbMLastMotorTorque = torque
	local neededPtoTorque = PowerConsumer.getTotalConsumedPtoTorque(self.vehicle)

	if 0 < neededPtoTorque then
		torque = math.max(torque - neededPtoTorque/self.ptoMotorRpmRatio, torque*0.1)
	end
	
	if self.slipFactor ~= nil then
		torque = math.max( torque * ( self.vehicle.mrGbMTransmissionEfficiency - self.vehicle.mrGbMTransmissionEfficiencyDec * ( 1 - self.slipFactor ) ), torque*0.1)
	end
	self.mrGbMLastTransTorque = torque		
	
	return torque, brakePedal
end

--**********************************************************************************************************	
-- mrGearboxMogliMotor:updateMotorRpm
--**********************************************************************************************************	
function mrGearboxMogliMotor:updateMotorRpm( dt )
	local vehicle = self.vehicle
	self.prevNonClampedMotorRpm  = self.nonClampedMotorRpm
	self.minRpm                  = math.max( self.idleRpm  - mrGearboxMogli.rpmMinus, 0 )
	self.maxRpm                  = self.ratedRpm + mrGearboxMogli.rpmPlus

	if next(vehicle.differentials) ~= nil and vehicle.motorizedNode ~= nil then
		self.nonClampedMotorRpm, self.clutchRpm, self.motorLoad = getMotorRotationSpeed(vehicle.motorizedNode)
		self.nonClampedMotorRpm  = self.nonClampedMotorRpm * mrGearboxMogli.factor30pi
		self.clutchRpm           = self.clutchRpm          * mrGearboxMogli.factor30pi
		self.requiredWheelTorque = self.maxMotorTorque*math.abs(self.gearRatio)
	else
		local gearRatio = self.getGearRatio(self)

		if vehicle.isServer then
			self.nonClampedMotorRpm = math.max(WheelsUtil.computeRpmFromWheels(vehicle)*gearRatio, 0)
		else
			self.nonClampedMotorRpm = math.max(WheelsUtil.computeRpmFromSpeed(vehicle)*gearRatio, 0)
		end
	end
	
	if self.noTransmission or self.noTorque then
		self.lastMotorRpm = Utils.clamp( self.currentRpmS, self.minRequiredRpm, self.ratedRpm )
	else
		self.lastMotorRpm = self.nonClampedMotorRpm
	end
	
	if     self.lastMotorRpm > self.maxRpm then
		self.lastMotorRpm = self.maxRpm
	elseif self.lastMotorRpm < self.minRpm then
		self.lastMotorRpm = self.minRpm
	end
end

--**********************************************************************************************************	
-- mrGearboxMogliMotor:updateGear
--**********************************************************************************************************	
function mrGearboxMogliMotor:updateGear(accelerationPedal, dt)

	local acceleration = math.max( accelerationPedal, 0 )
	if self.vehicle.mrGbMReverseActive then
		acceleration = -acceleration
	end
	
--**********************************************************************************************************	
-- VehicleMotor.updateGear I
	local requiredWheelTorque = math.huge

	if (0 < acceleration) == (0 < self.gearRatio) then
		requiredWheelTorque = self.requiredWheelTorque
	end

	--local requiredMotorRpm = PowerConsumer.getMaxPtoRpm(self.vehicle)*self.ptoMotorRpmRatio
	local wheelSpeedRpm = nil

	if math.abs(self.gearRatio) < 0.001 then
		wheelSpeedRpm = self.vehicle.lastSpeedReal*self.vehicle.movingDirection*1000*mrGearboxMogli.factor30pi
	else
		wheelSpeedRpm = self.clutchRpm/self.gearRatio
	end
--**********************************************************************************************************	

		self.ptoMotorRpmRatio  = self.original.ptoMotorRpmRatio
		currentSpeed           = 3.6 * wheelSpeedRpm * mrGearboxMogli.factorpi30 --3600 * self.vehicle.lastSpeedReal * self.vehicle.movingDirection
					
--**********************************************************************************************************	
		-- current RPM and power
		self.minRequiredRpm = self.idleRpm -- + self.vehicle.mrGbMWantedMinRpmRatio * ( self.ratedRpm - self.idleRpm - 100 )
		
		if self.vehicle.attachedImplements ~= nil and self.original.ptoMotorRpmRatio ~= nil then
			local ptoRpm 
			for _,a in pairs(self.vehicle.attachedImplements) do
				if a.object.getPtoRpm ~= nil and a.object.getDoConsumePtoPower ~= nil and a.object:getDoConsumePtoPower() then
					local r = a.object:getPtoRpm( )
					if r ~= nil and ( ptoRpm == nil or ptoRpm < r ) then
						ptoRpm = r
					end
				end
			end
			
			if ptoRpm ~= nil then
				local p = math.min( ptoRpm * self.original.ptoMotorRpmRatio, self.ratedRpm - 300 )
				self.ptoMotorRpmRatio = ( p - 50 ) / ptoRpm
				if self.minRequiredRpm < p then
					self.minRequiredRpm = p
				end
			end
		end
		
		local minRpmReduced      = math.max( self.idleRpm, self.minRequiredRpm - 200 )		
		local currentWheelRpm    = wheelSpeedRpm * math.abs( mrGearboxMogli.gearSpeedToRatio( self.vehicle, self.vehicle.mrGbMCurrentGearSpeed ) )		
		if self.vehicle.mrGbMReverseActive then currentWheelRpm = -currentWheelRpm end
		
		self.wheelRpmS      = self.wheelRpmS   + 0.1 * ( currentWheelRpm  - self.wheelRpmS )
		if not ( self.noTransmission ) then
			self.currentRpmS  = self.currentRpmS + 0.1 * ( self.nonClampedMotorRpm - self.currentRpmS )
		end
		self.noTransmission = false
		self.noTorque       = false 
		local lastMaxPossibleRpm = Utils.getNoNil( self.maxPossibleRpm, self.maxRpm )
		self.maxPossibleRpm = self.maxRpm

		motorLoad = Utils.clamp( self.motorLoad / math.max( self.torqueCurve:get( self.nonClampedMotorRpm ), 0.001 ), 0, 1 )
		self.motorLoadS	= self.motorLoadS	+ 0.04 * ( motorLoad - self.motorLoadS )
		
--**********************************************************************************************************		
		if     self.vehicle.mrGbMNeutralActive
				or ( self.nonClampedMotorRpm              <= self.idleRpm + 100
				 and accelerationPedal                    < -0.001
				 and self.vehicle.cruiseControl.state     == 0 ) then
		-- neutral or braking
			if currentSpeed < 0.3 then
				if self.vehicle.mrGbMAutoStartStop then
					self.vehicle:mbSetState11( "mrGbMNeutralActive", true) 
				end
				if self.vehicle.mrGbMAutomatic then 
					self.vehicle:mrGbMSetGear(1) 
				end
			end
			
			
			if self.vehicle.mrGbMGearShiftingNeeded > 0 then
				if g_currentMission.time>=self.vehicle.mrGbMGearShiftingTime then
					if self.vehicle.mrGbMGearShiftingNeeded < 2 then	
						self.vehicle:mrGbMDoGearShift() 
					end 
					self.vehicle.mrGbMGearShiftingNeeded = 0 
				elseif self.vehicle.mrGbMGearShiftingNeeded < 2 then	
					if self.vehicle.realClutchPercent <= 0 then
						self.vehicle:mrGbMDoGearShift() 
					end 
				end 
			end

			if self.vehicle.mrGbMAutoClutch then
				self.vehicle.realClutchPercent  = math.max( 0, self.vehicle.realClutchPercent -dt/self.vehicle.mrGbMClutchTimeDec ) 
			end
			self.slipFactor     = 0
			self.noTransmission = true
			self.minThrottle    = self.vehicle.mrGbMWantedMinRpmRatio
			self.minThrottleS   = self.vehicle.mrGbMWantedMinRpmRatio
			
			local acc = math.max( self.minThrottle, accelerationPedal )
						
			if acc > 0 then
				self.currentRpmS = Utils.clamp( self.lastMotorRpm + acc * dt * self.rpmIncFactor, self.minRequiredRpm, self.minRpm + acc * ( self.maxRpm - self.minRpm ) ) 
			else
				self.currentRpmS = Utils.clamp( self.lastMotorRpm - dt * self.rpmIncFactor, self.minRequiredRpm, self.maxRpm )
			end
--**********************************************************************************************************		
		else
--**********************************************************************************************************		
			-- acceleration for idle/minimum rpm
			local delta       = self.nonClampedMotorRpm - self.minRequiredRpm 
			self.minThrottle  = self.motorLoadS * ( self.minRequiredRpm - 0.7 * self.idleRpm ) / ( self.ratedRpm - 0.7 * self.idleRpm ) - Utils.clamp( 0.005 * delta, -0.1, 0.1 )
			self.minThrottle  = Utils.clamp( self.minThrottle, self.vehicle.mrGbMWantedMinRpmRatio, 1 ) 
			self.minThrottleS = self.minThrottleS + 0.1 * ( self.minThrottle - self.minThrottleS )
						
			if self.vehicle.mrGbMGearShiftingNeeded > 0 then
			-- during gear shifting
				
				if not ( self.vehicle.mrGbMAutoClutch ) then
				elseif self.vehicle.mrGbMGearShiftingNeeded == 2 and g_currentMission.time < self.vehicle.mrGbMGearShiftingTime then	
					if self.nonClampedMotorRpm > 0.9 * self.ratedRpm then
						self.vehicle.mrGbMGearShiftingNeeded  = 3
					else
						self.noTransmission = true
					end
					self.currentRpmS       = Utils.clamp( self.lastMotorRpm + dt * self.rpmIncFactor, self.minRequiredRpm, self.maxRpm ) 
				else
					self.noTorque          = true
					self.currentRpmS       = Utils.clamp( self.lastMotorRpm - dt * self.rpmIncFactor, self.minRequiredRpm, self.maxRpm )
				end

				if self.vehicle.mrGbMAutoClutch then
					self.maxPossibleRpm  = self.currentRpmS
				end
				
				if g_currentMission.time >= self.vehicle.mrGbMGearShiftingTime then
					if self.vehicle.mrGbMGearShiftingNeeded < 2 then	
						self.vehicle:mrGbMDoGearShift() 
					end 
					self.vehicle.mrGbMGearShiftingNeeded = 0 
					if self.vehicle.mrGbMAutoClutch then
						self.vehicle.realClutchPercent     = self.vehicle.mrGbMClutchPercent 
					end
					if currentWheelRpm > self.wheelRpmS then
						currentWheelRpm = self.wheelRpmS
					end
					if self.vehicle.mrGbMAfterShiftRpm ~= nil then
						self.maxPossibleRpm = self.vehicle.mrGbMAfterShiftRpm 
					end
				elseif self.vehicle.mrGbMGearShiftingNeeded < 2 then	
					if self.vehicle.realClutchPercent > 0 and g_currentMission.time < self.vehicle.mrGbMClutchShiftingTime then
						if self.vehicle.mrGbMAutoClutch then
							self.vehicle.realClutchPercent   = Utils.clamp( ( self.vehicle.mrGbMClutchShiftingTime - g_currentMission.time )/self.vehicle.mrGbMClutchShiftTime, 0, self.vehicle.realClutchPercent ) 					
						end
					else
						--self.vehicle.realClutchPercent     = 0 
						self.vehicle:mrGbMDoGearShift() 
					end 
				else
					--self.vehicle.realClutchPercent       = 0 
				end 
				
				self.noTransmission  = true
				self.slipFactor  = 0

			else
	--**********************************************************************************************************		
	-- normal drive with gear and clutch
				self.noTransmission = false
				--self.lowBrakeForceScale = self.vehicle.mrGbMRealMotorBrakeFx

	--**********************************************************************************************************		
	-- automatic shifting
				--no auto parkbrake when a gear is engaged
				local factorFx     = self.motorLoadS 
				
				-- semi automatic transmission
				if self.vehicle.mrGbMAutomatic then
					local diff = 0 
					local autoDownRpm, autoUpRpm = minRpmReduced, self.ratedRpm
					
					if self.vehicle.mrGbMAutoShiftDownRpm ~= nil then
						if      factorFx                   <  1
								and self.vehicle.mrGbMAutoShiftDownRpm >  minRpmReduced then
							diff = (1 - factorFx) * ( self.vehicle.mrGbMAutoShiftDownRpm - minRpmReduced ) 
						else
							diff = 0
						end
						autoDownRpm = math.max( minRpmReduced, self.vehicle.mrGbMAutoShiftDownRpm - diff ) 
					end 
					if self.vehicle.mrGbMAutoShiftUpRpm ~= nil then
						if      factorFx                   <  1
								and self.vehicle.mrGbMAutoShiftDownRpm ~= 0 
								and self.vehicle.mrGbMAutoShiftUpRpm   >  minRpmReduced * self.vehicle.mrGbMAutoShiftMinMaxFactor then
							diff = (1 - factorFx) * ( self.vehicle.mrGbMAutoShiftUpRpm - minRpmReduced * self.vehicle.mrGbMAutoShiftMinMaxFactor ) 
						else
							diff = 0
						end
						autoUpRpm  = math.min( self.ratedRpm, self.vehicle.mrGbMAutoShiftUpRpm - diff ) 
					end 

					--print(string.format("%4.0f %4.0f %4.0f %4.0f %4.0f",currentWheelRpm,self.nonClampedMotorRpm,minRpmReduced,autoDownRpm,autoUpRpm))
																			
					local wheelRpm
					
					-- shift down			
					wheelRpm = math.max( currentWheelRpm, self.wheelRpmS )
					if 			self.vehicle.mrGbMAutoShiftDownRpm ~= nil 
							and self.vehicle.mrGbMCurrentGear      > 1 
							and ( wheelRpm                 < minRpmReduced
								 or ( g_currentMission.time  > self.vehicle.mrGbMAutoShiftDownTimer 
									and wheelRpm               < autoDownRpm )) then
						self.vehicle:mrGbMSetGear(self.vehicle.mrGbMCurrentGear-1) 
					else
						-- shift up				
						wheelRpm = math.min( currentWheelRpm, self.wheelRpmS )
						if  self.vehicle.mrGbMAutoShiftUpRpm ~= nil 
								and self.vehicle.mrGbMCurrentGear< table.getn( self.vehicle.mrGbMGears )
								and self.clutchPercent           > 0.95 * self.vehicle.mrGbMMaxClutchPercent
								and g_currentMission.time        > self.vehicle.mrGbMAutoShiftUpTimer 	
								and wheelRpm                     > autoUpRpm then
							self.vehicle:mrGbMSetGear(self.vehicle.mrGbMCurrentGear+1) 
						end
					end
				end
			

	--**********************************************************************************************************		
	-- clutch
				local slipFactor = 1
				--if self.nonClampedMotorRpm < self.vehicle.mrGbMCloseRpm then
				if self.lastMotorRpm > 0 and self.lastMotorRpm > self.nonClampedMotorRpm then
					slipFactor = Utils.clamp( self.nonClampedMotorRpm / self.lastMotorRpm, 0, 1 )
				end
				self.slipFactor = self.slipFactor + 0.1 * ( slipFactor - self.slipFactor )
				
				local openRpm = minRpmReduced
				if self.vehicle.mrGbMOpenRpm > minRpmReduced then
					openRpm = minRpmReduced + factorFx * ( self.vehicle.mrGbMOpenRpm - minRpmReduced )
				end
					
				local refRpm   = math.max( self.minRequiredRpm, self.nonClampedMotorRpm )
				local closeRpm = refRpm
				if self.vehicle.mrGbMCloseRpm > refRpm then
					closeRpm = refRpm + factorFx * ( self.vehicle.mrGbMCloseRpm - refRpm )
				end
				
				if self.vehicle.mrGbMAutoClutch then 
					local targetClutchPercent = self:getClutchPercent( math.min( self.currentRpmS, self.nonClampedMotorRpm ), openRpm, closeRpm )
					if      dt > self.vehicle.mrGbMClutchTimeDec
							and dt > self.vehicle.mrGbMClutchTimeInc then
						self.vehicle.realClutchPercent = Utils.clamp( targetClutchPercent, 0, self.vehicle.mrGbMMaxClutchPercent ) 
					elseif targetClutchPercent < self.vehicle.realClutchPercent then
						self.vehicle.realClutchPercent = math.max( 0, self.vehicle.realClutchPercent - math.min( dt/self.vehicle.mrGbMClutchTimeDec, self.vehicle.realClutchPercent - targetClutchPercent ) ) 
					else
						local factor
						if currentWheelRpm < closeRpm then
							factor = dt/self.vehicle.mrGbMClutchTimeInc
						else
							factor = dt/self.vehicle.mrGbMClutchShiftTime
						end
						self.vehicle.realClutchPercent = math.min( self.vehicle.mrGbMMaxClutchPercent, self.vehicle.realClutchPercent + math.min( factor, targetClutchPercent - self.vehicle.realClutchPercent ) ) 
					end 
				else
					self.vehicle.realClutchPercent   = self.vehicle.mrGbMMaxClutchPercent
				end 					
			end 					
		end
		
		if self.vehicle.mrGbMAutoClutch then
			if self.vehicle.mrGbMClutchTime <= g_currentMission.time and g_currentMission.time < self.vehicle.mrGbMClutchTime + 5000 then
				self.clutchPercent = self.vehicle.mrGbMManualClutch + ( g_currentMission.time - self.vehicle.mrGbMClutchTime  ) / 5000 * ( self.vehicle.realClutchPercent - self.vehicle.mrGbMManualClutch  )
			else
				self.clutchPercent = self.vehicle.realClutchPercent
			end
		else
			self.clutchPercent = self.vehicle.mrGbMManualClutch
		end
		
		if self.noTransmission or self.clutchPercent <= 1E-3 then
			self.clutchPercent   = 0
			self.slipFactor      = 0
			self.noTransmission  = true
		else
			self.slipFactor       = self.clutchPercent
			self.maxPossibleRpm   = (1-self.clutchPercent) * self.maxRpm + self.clutchPercent * currentWheelRpm
			if self.maxPossibleRpm < self.prevNonClampedMotorRpm then
				self.maxPossibleRpm = self.prevNonClampedMotorRpm
			end
			if self.maxPossibleRpm < self.idleRpm then
				self.maxPossibleRpm = self.idleRpm
			end
			self.maxPossibleRpm = self.maxPossibleRpm + dt * self.rpmIncFactor
			--self.maxRpm = math.max( math.min( self.maxPossibleRpm, self.maxRpm ), self.original.maxRpm )
		end
		
		--if self.vehicle.mrGbMDebugTime == nil or self.vehicle.mrGbMDebugTime + 1000 < g_currentMission.time then
		--	self.vehicle.mrGbMDebugTime = g_currentMission.time
		--	print("mrGbM: "..tostring(math.floor(self.vehicle.mrGbMDebugTime*0.001))
		--						.." "..tostring(math.floor(self.nonClampedMotorRpm))
		--						.." "..tostring(self.rpmIncFactor)
		--						.." "..tostring(math.floor(currentWheelRpm))
		--						.." "..tostring(math.floor(self.maxPossibleRpm))
		--						.." "..tostring(math.floor(self.vehicle.lastSpeedReal*3600+0.5))
		--						.." "..tostring(self.noTransmission)
		--						.." "..tostring(0.1*math.floor(accelerationPedal*10))
		--						.." "..tostring(self.noTransmission)
		--						.." "..tostring(self.vehicle.isServer)
		--						.." "..tostring(self.vehicle.isClient))
		--end

--**********************************************************************************************************	
-- VehicleMotor.updateGear II
	self.gear, self.gearRatio = self.getBestGear(self, acceleration, wheelSpeedRpm, self.maxRpm*0.1, requiredWheelTorque, self.minRequiredRpm )
--**********************************************************************************************************	
end

--**********************************************************************************************************	
-- mrGearboxMogliMotor:getClutchPercent
--**********************************************************************************************************	
function mrGearboxMogliMotor:getClutchPercent( currrentRpm, openRpm, closeRpm, gearSpeed )
	local c = self.vehicle.realClutchPercent
	if currrentRpm <= self.idleRpm and openRpm > 0 then
		c = self.vehicle.mrGbMMinClutchPercent
	elseif currrentRpm >= closeRpm then
		c = self.vehicle.mrGbMMaxClutchPercent 					
	elseif closeRpm - openRpm >= 10 and currrentRpm >= openRpm then
		c = self.vehicle.realClutchPercent + ( self.vehicle.mrGbMMaxClutchPercent - self.vehicle.realClutchPercent ) * ( currrentRpm - openRpm ) / ( closeRpm - openRpm )
	elseif openRpm - self.idleRpm >= 10 then
		c = self.vehicle.mrGbMMinClutchPercent + ( self.vehicle.realClutchPercent - self.vehicle.mrGbMMinClutchPercent ) * ( currrentRpm - self.idleRpm ) / ( openRpm - self.idleRpm )
	elseif currrentRpm <= openRpm then
		c = self.vehicle.mrGbMMinClutchPercent
	end
	return c	
end


WheelsUtil.updateWheelsPhysics = Utils.overwrittenFunction( WheelsUtil.updateWheelsPhysics,mrGearboxMogli.newUpdateWheelsPhysics )
